import { InventoryService, QueriesUtil, UserService, IManagedObject, IResult } from '@c8y/client';
import { AlertService, BreadcrumbService, ModalService, NavigatorNode, AppStateService, NavigatorNodeData } from '@c8y/ngx-components';
import { ApiService } from '@c8y/ngx-components/api';
import { AssetNode } from './asset-node';
import { AssetNavigatorConfig } from './asset-node-config.model';
import { DynamicGroupNode } from './dynamic-group-node';
import { DeviceGroupService } from './group.service';
export interface AssetNodeMo {
    id: string;
    type: string;
}
export declare class AssetNodeService {
    inventory: InventoryService;
    groups: DeviceGroupService;
    apiService: ApiService;
    modal: ModalService;
    alert: AlertService;
    protected breadcrumbService: BreadcrumbService;
    protected user: UserService;
    protected appState: AppStateService;
    moduleConfig: AssetNavigatorConfig;
    rootNode: AssetNode;
    firstUrl: boolean;
    draggedData: AssetNode;
    queriesUtil: QueriesUtil;
    protected PAGE_SIZE: number;
    constructor(inventory: InventoryService, groups: DeviceGroupService, apiService: ApiService, modal: ModalService, alert: AlertService, breadcrumbService: BreadcrumbService, user: UserService, appState: AppStateService, moduleConfig: AssetNavigatorConfig);
    createRootNode(config?: NavigatorNodeData): AssetNode;
    createDynamicGroupNode(config: any): DynamicGroupNode;
    createAssetNode(config: any): AssetNode;
    createChildNode(managedObject: any): AssetNode | DynamicGroupNode;
    getRootNodes(customFilter?: any): Promise<any>;
    getGroupItems(moId: string, extraFilter?: object): Promise<import("@c8y/client").IResultList<IManagedObject>>;
    getDynamicGroupItems(groupQuery: string, filterObj?: any): Promise<import("@c8y/client").IResultList<IManagedObject>>;
    getDeviceChildren(moId: string, extraFilter?: object): Promise<import("@c8y/client").IResultList<IManagedObject>>;
    groupQueryFilter(moId: string): string;
    navRootQueryFilter(): {
        __filter: {
            type: string;
        };
        __orderby: any[];
    };
    rootQueryFilter(): {
        __filter: {
            type: string;
        };
        __orderby: any[];
    };
    onUpdate({ mo, root }: {
        mo: any;
        root: any;
    }): import("rxjs").Observable<any>;
    isNewManagedObjectRoot(response?: Partial<IResult<IManagedObject>>): boolean;
    /**
     * There could be multiple breadcrumbs for devices,
     * so we set a preferred one on click on a device.
     * @param parents The parent nodes of the device to select the prefered one.
     */
    preferBreadcrumb(parents: NavigatorNode[]): void;
    protected createFilter(extraParams?: any): any;
    private buildCombinedQuery;
}
