import { OnInit, ChangeDetectorRef } from '@angular/core';
import { TranslateService } from '@ngx-translate/core';
import { GroupNode } from './group-node';
import { Subject } from 'rxjs';
import { AssetSelectorComponent } from './asset-selector.component';
import { IManagedObject } from '@c8y/client';
export declare class AssetSelectorNodeComponent implements OnInit {
    private translateService;
    private cd;
    private parentNode;
    /**
     * The current node.
     */
    node: GroupNode;
    /**
     * All preselected items
     */
    preselected: Array<Partial<IManagedObject>>;
    /**
     *  Should the path be shown
     */
    showPath: boolean;
    /**
     * The current path to the node
     */
    breadcrumb: string;
    /**
     * @ignore
     */
    level: number;
    /**
     * The selection status of the node
     */
    checked: boolean;
    /**
     * @ignore
     */
    unsubscribe$: Subject<any>;
    /**
     * @ignore
     */
    get expandTitle(): any;
    /**
     * @ignore only di
     */
    constructor(translateService: TranslateService, cd: ChangeDetectorRef, parentNode: AssetSelectorComponent);
    /**
     * @ignore
     */
    ngOnInit(): Promise<void>;
    /**
     * Opens a node.
     */
    click(): void;
    /**
     * TODO: Only level used. Breadcrumbs needs to be implemented.
     */
    setupBreadcrumbsAndLevel(node: GroupNode): void;
    /**
     * Selects the node and emits a change on the parent component.
     * @param node The node to select.
     */
    selected(node: GroupNode): void;
    /**
     * @ignore
     */
    ngOnDestroy(): void;
    private isPreselected;
    private updateSelection;
}
