import { EventEmitter, OnInit } from '@angular/core';
import { GroupNodeService } from './group-node.service';
import { GroupNode } from './group-node';
import { IManagedObject } from '@c8y/client';
/**
 * Displays a hierarchical tree selector for assets.
 */
export declare class AssetSelectorComponent implements OnInit {
    private groupNodeService;
    /**
     * An array of predefined nodes.
     */
    selected: IManagedObject[];
    /**
     * Emits if one item was selected (all currently selected nodes).
     */
    onChange: EventEmitter<IManagedObject[]>;
    /**
     * @ignore
     */
    rootNode: GroupNode;
    /**
     * @ignore only DI
     */
    constructor(groupNodeService: GroupNodeService);
    /**
     * @ignore
     */
    ngOnInit(): void;
    /**
     * Adds an managed object to the selected array and emits the change.
     * @param selectedMo The selected asset.
     */
    select(selectedMo: IManagedObject): void;
    /**
     * Removes a managed object from the selected array and emits the change.
     * @param selectedMo The selected asset.
     */
    deselect(selectedMo: IManagedObject): void;
    getIndexOfSelected(selected: Array<Partial<IManagedObject>>, selectedMo: IManagedObject): number;
}
