import { SimpleChanges } from '@angular/core';
import { TfaStrategy, TenantLoginOptionType } from '@c8y/client';
import { AuthConfiguration } from './auth-configuration.model';
declare enum TfaStateEnum {
    TFA_UNDEFINED_BY_SYSTEM = 0,
    TFA_ENFORCED_FOR_GROUP = 1,
    TFA_ENABLED_BY_SYSTEM = 2,
    TFA_ENFORCED_BY_SYSTEM = 3
}
export declare class TfaSettingsComponent {
    authConfiguration: AuthConfiguration;
    preferredLoginOptionType: TenantLoginOptionType;
    smsGatewayAvailable: boolean;
    tfaStateEnum: typeof TfaStateEnum;
    tfaStrategyEnum: typeof TfaStrategy;
    tenantLoginOptionTypeEnum: typeof TenantLoginOptionType;
    TOTP_REQUIRES_OAUTH_POPOVER: any;
    SMS_APP_NOT_SUBSCRIBED_POPOVER: any;
    TFA_IS_ENFORCED_BY_SYSTEM_POPOVER: any;
    TFA_IS_ENABLED_BY_SYSTEM_POPOVER: any;
    TOKEN_VALIDITY_DETERMINED_BY_JWT_POPOVER: any;
    TFA_IS_ENABLED_BY_ENFORCE_FOR_GROUP_POPOVER: any;
    ngOnChanges(changes: SimpleChanges): void;
    ngDoCheck(): void;
    get tenantTfaTokenValidity(): any;
    set tenantTfaTokenValidity(value: any);
    get tenantTfaPinValidity(): any;
    set tenantTfaPinValidity(value: any);
    get tenantTfaEnabled(): any;
    set tenantTfaEnabled(value: any);
    get tenantTfaEnforced(): any;
    set tenantTfaEnforced(value: any);
    get tenantTfaStrategy(): any;
    set tenantTfaStrategy(value: any);
    get systemTfaEnforcedGroup(): any;
    get systemTfaTenantScopeSettingEnabled(): any;
    get systemTfaEnabled(): any;
    get systemTfaEnforced(): any;
    get tfaState(): TfaStateEnum;
    get tfaBySmsCanBeSet(): boolean;
    get tfaByTotpCanBeSet(): boolean;
}
export {};
