(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@c8y/ngx-components'), require('rxjs/operators'), require('@angular/router'), require('@c8y/client'), require('@angular/forms'), require('ngx-bootstrap/popover'), require('lodash-es')) :
    typeof define === 'function' && define.amd ? define('@c8y/ngx-components/connectivity', ['exports', '@angular/core', '@c8y/ngx-components', 'rxjs/operators', '@angular/router', '@c8y/client', '@angular/forms', 'ngx-bootstrap/popover', 'lodash-es'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.c8y = global.c8y || {}, global.c8y["ngx-components"] = global.c8y["ngx-components"] || {}, global.c8y["ngx-components"].connectivity = {}), global.ng.core, global.c8y["ngx-components"], global.rxjs.operators, global.ng.router, global.client, global.ng.forms, global.popover, global.lodashEs));
})(this, (function (exports, core, ngxComponents, operators, router, client, forms, popover, lodashEs) { 'use strict';

    var AbstractConnectivityTabFactory = /** @class */ (function () {
        function AbstractConnectivityTabFactory(router, guard) {
            this.router = router;
            this.guard = guard;
        }
        AbstractConnectivityTabFactory.prototype.get = function () {
            return this.router.url.match(/connectivitySettings/g) ? this.tab() : [];
        };
        AbstractConnectivityTabFactory.prototype.tab = function () {
            var _this = this;
            return ngxComponents.toObservable(this.guard.canActivate(this.router.routerState.snapshot.root, this.router.routerState.snapshot)).pipe(operators.map(function (canActivate) { return (canActivate ? _this.config() : null); }));
        };
        return AbstractConnectivityTabFactory;
    }());

    var AbstractConnectivityNodeFactory = /** @class */ (function () {
        function AbstractConnectivityNodeFactory(tabFactory) {
            this.tabFactory = tabFactory;
            this.connectivityNode = new ngxComponents.NavigatorNode({
                parent: ngxComponents.gettext('Settings'),
                label: ngxComponents.gettext('Connectivity'),
                path: 'connectivitySettings',
                icon: 'plug',
                preventDuplicates: true
            });
        }
        AbstractConnectivityNodeFactory.prototype.get = function () {
            var _this = this;
            return ngxComponents.toObservable(this.tabFactory.tab()).pipe(operators.map(function (tab) {
                return !!tab ? [_this.connectivityNode] : [];
            }));
        };
        return AbstractConnectivityNodeFactory;
    }());
    AbstractConnectivityNodeFactory.decorators = [
        { type: core.Injectable }
    ];
    AbstractConnectivityNodeFactory.ctorParameters = function () { return [
        { type: AbstractConnectivityTabFactory }
    ]; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var ActilityGuard = /** @class */ (function () {
        function ActilityGuard(applicationService) {
            this.applicationService = applicationService;
        }
        ActilityGuard.prototype.canActivate = function (route, state) {
            if (this.showActilityProvider === undefined) {
                this.showActilityProvider = this.applicationService
                    .isAvailable(ActilityGuard.applicationName)
                    .then(function (result) { return result && result.data; });
            }
            return this.showActilityProvider;
        };
        return ActilityGuard;
    }());
    ActilityGuard.applicationName = 'actility';
    ActilityGuard.decorators = [
        { type: core.Injectable }
    ];
    ActilityGuard.ctorParameters = function () { return [
        { type: client.ApplicationService }
    ]; };

    var ActilityTabFactory = /** @class */ (function (_super) {
        __extends(ActilityTabFactory, _super);
        function ActilityTabFactory(router, guard) {
            var _this = _super.call(this, router, guard) || this;
            _this.router = router;
            _this.guard = guard;
            _this.tabConfig = {
                label: ngxComponents.gettext('Actility LoRa provider settings'),
                path: '/connectivitySettings/actility_lora_provider_settings',
                icon: 'c8y-device'
            };
            return _this;
        }
        ActilityTabFactory.prototype.config = function () {
            return this.tabConfig;
        };
        return ActilityTabFactory;
    }(AbstractConnectivityTabFactory));
    ActilityTabFactory.decorators = [
        { type: core.Injectable }
    ];
    ActilityTabFactory.ctorParameters = function () { return [
        { type: router.Router },
        { type: ActilityGuard }
    ]; };

    var ActilityNodeFactory = /** @class */ (function (_super) {
        __extends(ActilityNodeFactory, _super);
        function ActilityNodeFactory(tabFactory) {
            var _this = _super.call(this, tabFactory) || this;
            _this.tabFactory = tabFactory;
            return _this;
        }
        return ActilityNodeFactory;
    }(AbstractConnectivityNodeFactory));
    ActilityNodeFactory.decorators = [
        { type: core.Injectable }
    ];
    ActilityNodeFactory.ctorParameters = function () { return [
        { type: ActilityTabFactory }
    ]; };

    var ActilityModule = /** @class */ (function () {
        function ActilityModule() {
        }
        return ActilityModule;
    }());
    ActilityModule.decorators = [
        { type: core.NgModule, args: [{
                    providers: [
                        ActilityGuard,
                        ActilityTabFactory,
                        {
                            provide: ngxComponents.HOOK_NAVIGATOR_NODES,
                            useClass: ActilityNodeFactory,
                            multi: true
                        },
                        {
                            provide: ngxComponents.HOOK_TABS,
                            useClass: ActilityTabFactory,
                            multi: true
                        }
                    ]
                },] }
    ];

    var ImpactConnectivityService = /** @class */ (function () {
        function ImpactConnectivityService(client) {
            this.client = client;
            this.microserviceUrl = '/service/impact/connectivity';
            this.header = { 'Content-Type': 'application/json' };
        }
        ImpactConnectivityService.prototype.getOptions = function () {
            var options = {
                method: 'GET',
                headers: this.header
            };
            return this.client.fetch("" + this.microserviceUrl, options);
        };
        ImpactConnectivityService.prototype.updateOptions = function (impactOptions) {
            var options = {
                method: 'POST',
                headers: this.header,
                body: JSON.stringify(impactOptions)
            };
            return this.client.fetch("" + this.microserviceUrl, options);
        };
        ImpactConnectivityService.prototype.deleteOptions = function () {
            var options = {
                method: 'DELETE',
                headers: this.header
            };
            return this.client.fetch("" + this.microserviceUrl, options);
        };
        return ImpactConnectivityService;
    }());
    ImpactConnectivityService.decorators = [
        { type: core.Injectable }
    ];
    ImpactConnectivityService.ctorParameters = function () { return [
        { type: client.FetchClient }
    ]; };

    var ImpactGuard = /** @class */ (function () {
        function ImpactGuard(applicationService) {
            this.applicationService = applicationService;
        }
        ImpactGuard.prototype.canActivate = function (route, state) {
            if (this.showImpactProvider === undefined) {
                this.showImpactProvider = this.applicationService
                    .isAvailable(ImpactGuard.applicationName)
                    .then(function (result) { return result && result.data; });
            }
            return this.showImpactProvider;
        };
        return ImpactGuard;
    }());
    ImpactGuard.applicationName = 'impact';
    ImpactGuard.decorators = [
        { type: core.Injectable }
    ];
    ImpactGuard.ctorParameters = function () { return [
        { type: client.ApplicationService }
    ]; };

    var ImpactTabFactory = /** @class */ (function () {
        function ImpactTabFactory(router, guard) {
            this.router = router;
            this.guard = guard;
            this.config = {
                label: ngxComponents.gettext('IMPACT provider settings'),
                path: '/connectivitySettings/impact_provider_settings',
                icon: 'plug'
            };
        }
        ImpactTabFactory.prototype.get = function () {
            return this.router.url.match(/connectivitySettings/g) ? this.tab() : [];
        };
        ImpactTabFactory.prototype.tab = function () {
            var _this = this;
            return ngxComponents.toObservable(this.guard.canActivate(this.router.routerState.snapshot.root, this.router.routerState.snapshot)).pipe(operators.map(function (canActivate) { return (canActivate ? _this.config : null); }));
        };
        return ImpactTabFactory;
    }());
    ImpactTabFactory.decorators = [
        { type: core.Injectable }
    ];
    ImpactTabFactory.ctorParameters = function () { return [
        { type: router.Router },
        { type: ImpactGuard }
    ]; };

    var ImpactNodeFactory = /** @class */ (function () {
        function ImpactNodeFactory(tabFactory) {
            this.tabFactory = tabFactory;
            this.connectivityNode = new ngxComponents.NavigatorNode({
                parent: ngxComponents.gettext('Settings'),
                label: ngxComponents.gettext('Connectivity'),
                path: 'connectivitySettings',
                icon: 'plug',
                preventDuplicates: true
            });
        }
        ImpactNodeFactory.prototype.get = function () {
            var _this = this;
            return ngxComponents.toObservable(this.tabFactory.tab()).pipe(operators.map(function (tab) {
                return !!tab ? [_this.connectivityNode] : [];
            }));
        };
        return ImpactNodeFactory;
    }());
    ImpactNodeFactory.decorators = [
        { type: core.Injectable }
    ];
    ImpactNodeFactory.ctorParameters = function () { return [
        { type: ImpactTabFactory }
    ]; };

    exports.TenantConnectionStatus = void 0;
    (function (TenantConnectionStatus) {
        TenantConnectionStatus["NO_CONNECTION"] = "NO_CONNECTION";
        TenantConnectionStatus["CONNECTING_IN_PROGRESS"] = "CONNECTING_IN_PROGRESS";
        TenantConnectionStatus["CONNECTED_SUCCESSFULLY"] = "CONNECTED_SUCCESSFULLY";
        TenantConnectionStatus["CONNECTED_FAILED"] = "CONNECTED_FAILED";
        TenantConnectionStatus["UNKNOWN"] = "UNKNOWN";
    })(exports.TenantConnectionStatus || (exports.TenantConnectionStatus = {}));

    var ImpactProviderSettingsComponent = /** @class */ (function () {
        function ImpactProviderSettingsComponent(impactService, formBuilder, modal, alert) {
            this.impactService = impactService;
            this.formBuilder = formBuilder;
            this.modal = modal;
            this.alert = alert;
            this.isEdit = false;
            this.credentialsExist = false;
        }
        ImpactProviderSettingsComponent.prototype.ngOnInit = function () {
            return __awaiter(this, void 0, void 0, function () {
                var response, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            this.initForm();
                            return [4 /*yield*/, this.impactService.getOptions()];
                        case 1:
                            response = _b.sent();
                            _a = this;
                            return [4 /*yield*/, response.json()];
                        case 2:
                            _a.connectionStatus = _b.sent();
                            if (this.connectionStatus && this.connectionStatus.options) {
                                this.formGroup.patchValue(Object.assign({}, this.connectionStatus.options));
                                this.credentialsExist = true;
                            }
                            else {
                                this.isEdit = true;
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        ImpactProviderSettingsComponent.prototype.replaceCredentials = function () {
            this.isEdit = true;
        };
        ImpactProviderSettingsComponent.prototype.saveCredentials = function () {
            return __awaiter(this, void 0, void 0, function () {
                var updated, response, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            if (!this.formGroup.valid) return [3 /*break*/, 5];
                            this.connectionStatus.status = exports.TenantConnectionStatus.CONNECTING_IN_PROGRESS;
                            return [4 /*yield*/, this.safelyUpdateCredentials(this.formGroup.value)];
                        case 1:
                            updated = _b.sent();
                            if (!updated) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.impactService.getOptions()];
                        case 2:
                            response = _b.sent();
                            _a = this;
                            return [4 /*yield*/, response.json()];
                        case 3:
                            _a.connectionStatus = _b.sent();
                            if (this.connectionStatus.status === exports.TenantConnectionStatus.CONNECTED_SUCCESSFULLY) {
                                this.isEdit = false;
                            }
                            this.alert.success(ngxComponents.gettext('Credentials saved.'));
                            return [3 /*break*/, 5];
                        case 4:
                            this.connectionStatus.status = exports.TenantConnectionStatus.UNKNOWN;
                            _b.label = 5;
                        case 5: return [2 /*return*/];
                    }
                });
            });
        };
        ImpactProviderSettingsComponent.prototype.deleteCredentials = function () {
            return __awaiter(this, void 0, void 0, function () {
                var ex_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 3, , 4]);
                            return [4 /*yield*/, this.modal.confirm(ngxComponents.gettext('Delete credentials'), ngxComponents.gettext('You are about to delete your IMPACT credentials. Deleting credentials will break connection to IMPACT instance. Do you want to proceed?'), ngxComponents.Status.DANGER, { ok: ngxComponents.gettext('Delete'), cancel: ngxComponents.gettext('Cancel') })];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.safelyDeleteCredentials()];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            ex_1 = _a.sent();
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        ImpactProviderSettingsComponent.prototype.initForm = function () {
            this.formGroup = this.formBuilder.group({
                baseUrl: [],
                user: ['', forms.Validators.required],
                password: ['', forms.Validators.required],
                groupName: [],
                initializeDevices: [false]
            });
        };
        ImpactProviderSettingsComponent.prototype.resetForm = function () {
            this.formGroup.reset();
        };
        ImpactProviderSettingsComponent.prototype.safelyUpdateCredentials = function (options) {
            return __awaiter(this, void 0, void 0, function () {
                var res, data, _a, ex_2;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 7, , 8]);
                            return [4 /*yield*/, this.impactService.updateOptions(options)];
                        case 1:
                            res = _b.sent();
                            if (!(res && res.status !== 200)) return [3 /*break*/, 5];
                            if (!res.json) return [3 /*break*/, 3];
                            return [4 /*yield*/, res.json()];
                        case 2:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            _a = undefined;
                            _b.label = 4;
                        case 4:
                            data = _a;
                            this.alert.addServerFailure({ data: data, res: res });
                            return [2 /*return*/, Promise.resolve(false)];
                        case 5: return [2 /*return*/, Promise.resolve(true)];
                        case 6: return [3 /*break*/, 8];
                        case 7:
                            ex_2 = _b.sent();
                            this.alert.addServerFailure(ex_2);
                            return [2 /*return*/, Promise.resolve(false)];
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        ImpactProviderSettingsComponent.prototype.safelyDeleteCredentials = function () {
            return __awaiter(this, void 0, void 0, function () {
                var res, data, _a, ex_3;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 7, , 8]);
                            return [4 /*yield*/, this.impactService.deleteOptions()];
                        case 1:
                            res = _b.sent();
                            if (!(res && res.status !== 200)) return [3 /*break*/, 5];
                            if (!res.json) return [3 /*break*/, 3];
                            return [4 /*yield*/, res.json()];
                        case 2:
                            _a = _b.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            _a = undefined;
                            _b.label = 4;
                        case 4:
                            data = _a;
                            this.alert.addServerFailure({ data: data, res: res });
                            return [3 /*break*/, 6];
                        case 5:
                            this.credentialsExist = false;
                            this.resetForm();
                            this.connectionStatus = null;
                            this.alert.success(ngxComponents.gettext('Credentials deleted.'));
                            _b.label = 6;
                        case 6: return [3 /*break*/, 8];
                        case 7:
                            ex_3 = _b.sent();
                            this.alert.addServerFailure(ex_3);
                            return [3 /*break*/, 8];
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        return ImpactProviderSettingsComponent;
    }());
    ImpactProviderSettingsComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'c8y-impact-provider-settings',
                    template: "<div class=\"row\">\n  <div class=\"col-xs-12 col-md-8\">\n    <form class=\"card card--fullpage\"\n      [formGroup]=\"formGroup\"\n      novalidate\n    >\n      <div class=\"card-header separator\">\n        <h4 class=\"card-title\" translate>Credentials</h4>\n      </div>\n      <div class=\"inner-scroll\">\n        <div class=\"card-block\" *ngIf=\"isEdit\">\n          <c8y-form-group>\n            <label for=\"baseUrl\" translate>\n              Base URL\n            </label>\n            <input\n              id=\"baseUrl\"\n              name=\"baseUrl\"\n              type=\"text\"\n              class=\"form-control\"\n              placeholder=\"{{ 'e.g. https://impact.example.com' | translate }}\"\n              autocomplete=\"off\"\n              formControlName=\"baseUrl\"\n            />\n          </c8y-form-group>\n          <c8y-form-group>\n            <label for=\"user\" translate>\n              User\n            </label>\n            <input\n              id=\"user\"\n              name=\"user\"\n              type=\"text\"\n              class=\"form-control\"\n              placeholder=\"{{ 'e.g. joe`LOCALIZE`' | translate }}\"\n              required\n              autocomplete=\"off\"\n              formControlName=\"user\"\n            />\n            <c8y-messages>\n              <c8y-message *ngIf=\"formGroup?.controls?.user?.errors?.required\" translate>\n                This field is required.\n              </c8y-message>\n            </c8y-messages>\n          </c8y-form-group>\n          <c8y-form-group>\n            <label for=\"password\" translate>\n              Password\n            </label>\n            <input\n              id=\"password\"\n              name=\"password\"\n              type=\"password\"\n              class=\"form-control\"\n              placeholder=\"{{ 'e.g. my_password' | translate }}\"\n              required\n              autocomplete=\"off\"\n              formControlName=\"password\"\n            />\n            <c8y-messages>\n              <c8y-message *ngIf=\"formGroup?.controls?.password?.errors?.required\" translate>\n                This field is required.\n              </c8y-message>\n            </c8y-messages>\n          </c8y-form-group>\n          <c8y-form-group>\n            <label for=\"groupName\" translate>\n              IMPACT group name prefix\n            </label>\n            <input\n              id=\"groupName\"\n              name=\"groupName\"\n              type=\"text\"\n              class=\"form-control\"\n              placeholder=\"{{ 'e.g. Europe.Nokia`LOCALIZE`' | translate }}\"\n              formControlName=\"groupName\"\n            />\n          </c8y-form-group>\n        </div>\n        <div class=\"card-block bg-gray-white\">\n          <div class=\"d-flex\">\n            <c8y-status-display\n              [status]=\"connectionStatus?.status\"\n              [baseUrl]=\"connectionStatus?.options?.baseUrl\"\n            ></c8y-status-display>\n\n            <div class=\"d-flex flex-item-middle flex-item-right\">\n              <label class=\"c8y-switch\">\n                <input type=\"checkbox\" formControlName=\"initializeDevices\" />\n                <span></span> {{ 'Refresh devices' | translate }}\n              </label>\n              <a\n                container=\"body\"\n                class=\"btn-clean m-l-4 flex-item-middle\"\n                popover=\"{{ 'Refresh device resources as part of connecting' | translate }}\"\n                placement=\"right\"\n                outsideClick=\"false\"\n              >\n                <i c8yIcon=\"question-circle-o text-primary\"></i>\n              </a>\n            </div>\n          </div>\n        </div>\n        <div class=\"card-block\" *ngIf=\"credentialsExist && !isEdit\">\n          <p translate>\n            Credentials already provided.<br />\n            Click \"Replace credentials\" below to overwrite them.\n          </p>\n        </div>\n      </div>\n      <div class=\"card-footer separator\">\n        <button class=\"btn btn-default\"\n          title=\"{{ 'Replace credentials' | translate }}\"\n          type=\"submit\"\n          *ngIf=\"!isEdit\"\n          (click)=\"replaceCredentials()\"\n        >\n          {{ 'Replace credentials' | translate }}\n        </button>\n        <button class=\"btn btn-danger\"\n          title=\"{{ 'Delete credentials' | translate }}\"\n          type=\"button\"\n          *ngIf=\"credentialsExist && isEdit\"\n          (click)=\"deleteCredentials()\"\n        >\n          {{ 'Delete credentials' | translate }}\n        </button>\n        <button class=\"btn btn-primary\"\n          title=\"{{ 'Save credentials & connect' | translate }}\"\n          type=\"button\"\n          *ngIf=\"isEdit\"\n          [disabled]=\"formGroup.invalid\"\n          (click)=\"saveCredentials()\"\n        >\n          {{ 'Save credentials & connect' | translate }}\n        </button>\n      </div>\n    </form>\n  </div>\n</div>\n"
                },] }
    ];
    ImpactProviderSettingsComponent.ctorParameters = function () { return [
        { type: ImpactConnectivityService },
        { type: forms.FormBuilder },
        { type: ngxComponents.ModalService },
        { type: ngxComponents.AlertService }
    ]; };

    var StatusDisplayComponent = /** @class */ (function () {
        function StatusDisplayComponent() {
        }
        Object.defineProperty(StatusDisplayComponent.prototype, "status", {
            set: function (status) {
                switch (status) {
                    case exports.TenantConnectionStatus.CONNECTED_SUCCESSFULLY:
                        this.icon = 'success';
                        this.statusName = ngxComponents.gettext('Connected successfully');
                        break;
                    case exports.TenantConnectionStatus.CONNECTED_FAILED:
                        this.icon = 'failed';
                        this.statusName = ngxComponents.gettext('Connection failed');
                        break;
                    case exports.TenantConnectionStatus.CONNECTING_IN_PROGRESS:
                        this.icon = 'connecting';
                        this.statusName = ngxComponents.gettext('Connection in progress');
                        break;
                    case exports.TenantConnectionStatus.NO_CONNECTION:
                        this.icon = 'no-connection';
                        this.statusName = ngxComponents.gettext('No connection');
                        break;
                    default:
                        this.icon = 'unknown';
                        this.statusName = ngxComponents.gettext('Unknown`connection status`');
                }
            },
            enumerable: false,
            configurable: true
        });
        return StatusDisplayComponent;
    }());
    StatusDisplayComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'c8y-status-display',
                    template: "<div class=\"d-flex\">\n  <div class=\"dot dot-64 p-16\"\n    [ngClass]=\"{\n      'dot-success': icon === 'success',\n      'dot-danger': icon === 'failed',\n      'dot-info': icon === 'connecting',\n      'dot-default': icon === 'no-connection' || icon === 'unknown'\n    }\"\n  >\n    <!-- unknown-->\n    <svg viewBox=\"0 0 17 23\" *ngIf=\"icon === 'unknown'\">\n        <g id=\"Page-1\" stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n            <g id=\"Artboard\" transform=\"translate(-24.000000, -20.000000)\" fill=\"currentColor\" fill-rule=\"nonzero\">\n                <path d=\"M34.4437635,36.1999921 C34.8390765,36.1999921 35.1312643,35.7531166 35.1312643,35.3749911 C35.1312643,34.8765531 35.7672026,33.6906141 36.7812663,33.1062384 C38.4140808,32.1952999 40.6312709,30.9406109 40.6312709,27.674982 C40.6312709,23.7390398 36.506266,20.7999738 32.8281366,20.7999738 C29.3218824,20.7999738 26.7093793,22.2952881 24.8531271,25.3718542 C24.6640644,25.6812296 24.7328144,26.059355 25.0250023,26.2827928 L27.8437557,28.4312329 C27.9812558,28.5171705 28.118756,28.568733 28.2734437,28.568733 C28.4625064,28.568733 28.6687566,28.4656079 28.8062568,28.2937327 C29.8203205,27.0218562 30.232821,26.6093557 30.6453215,26.3171679 C31.0234469,26.059355 31.7281353,25.8187298 32.5015737,25.8187298 C33.8937629,25.8187298 35.1484519,26.6781058 35.1484519,27.6406069 C35.1484519,28.7406082 34.5984512,29.3077964 33.2750121,29.9093596 C31.7625103,30.5968605 29.7000079,32.3843626 29.7000079,34.4640526 L29.7000079,35.237491 C29.7000079,35.6156164 29.9406332,36.1999921 30.3187586,36.1999921 L34.4437635,36.1999921 Z M34.5125136,42.7999934 C34.8906391,42.7999934 35.2000079,42.4906246 35.2000079,42.1124992 L35.2000079,37.9874943 C35.2000079,37.6093688 34.8906391,37.2999934 34.5125136,37.2999934 L30.3875087,37.2999934 C30.0093832,37.2999934 29.7000079,37.6093688 29.7000079,37.9874943 L29.7000079,42.1124992 C29.7000079,42.4906246 30.0093832,42.7999934 30.3875087,42.7999934 L34.5125136,42.7999934 Z\" id=\"\uF128\"></path>\n            </g>\n        </g>\n    </svg>\n    <!-- no connection -->\n    <svg viewBox=\"0 0 32 32\" *ngIf=\"icon === 'no-connection'\">\n      <g id=\"Page-1\" stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n          <g id=\"Artboard-Copy\" transform=\"translate(-16.000000, -16.000000)\" fill=\"currentColor\" fill-rule=\"nonzero\">\n              <path d=\"M36.090359,41.560381 L32.5058901,45.1435604 C28.9330257,48.7177143 23.134696,48.7177143 19.5592528,45.1435604 C15.9850989,41.5681172 15.9863883,35.7710769 19.5592528,32.1969231 L23.1424323,28.6137436 L25.8772015,31.3485128 L22.294022,34.9316923 C20.2335971,36.9921172 20.2335971,40.3470769 22.294022,42.4062125 C24.3570257,44.4692161 27.710696,44.4692161 29.7711209,42.4062125 L33.3543004,38.8256117 L36.090359,41.560381 L36.090359,41.560381 Z M32.1964396,19.5597363 L28.6132601,23.1429158 L31.3480293,25.877685 L34.9324982,22.2945055 C36.9929231,20.2340806 40.3465934,20.2340806 42.4044396,22.2957949 C44.470022,24.3562198 44.470022,27.7098901 42.4095971,29.770315 L38.8264176,33.3534945 L41.5611868,36.0882637 L45.1443663,32.5063736 C48.7172308,28.9309304 48.7172308,23.1338901 45.1443663,19.5597363 C41.5676337,15.9855824 35.7705934,15.9855824 32.1964396,19.5597363 Z M24.5310916,18.5346813 L26.3877949,18.2716484 L26.9525421,22.2467985 L25.0984176,22.5111209 L24.5310916,18.5346813 L24.5310916,18.5346813 Z M18.2711649,26.386989 L18.5367766,24.5289963 L22.5132161,25.0963223 L22.2476044,26.9530256 L18.2711649,26.386989 Z M24.4511502,23.1364689 L23.1256704,24.4645275 L20.2825934,21.6240293 L21.6093627,20.2972601 L24.4511502,23.1364689 L24.4511502,23.1364689 Z M40.1699487,46.1647473 L38.3119561,46.4277802 L37.7472088,42.45263 L39.6026227,42.1883077 L40.1699487,46.1647473 L40.1699487,46.1647473 Z M46.4311649,38.3124396 L46.1642638,40.1704322 L42.1878242,39.6043956 L42.4547253,37.7464029 L46.4311649,38.3124396 Z M40.2511795,41.5616703 L41.57537,40.2349011 L44.4184469,43.0766886 L43.0916777,44.4034579 L40.2511795,41.5616703 Z\" id=\"Shape-Copy-2\"></path>\n          </g>\n      </g>\n  </svg>\n    <!-- Connecting -->\n    <svg viewBox=\"0 0 29 32\" class=\"icon-spin\" *ngIf=\"icon === 'connecting'\">\n      <g id=\"Page-1\" stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <g id=\"Artboard-Copy-2\" transform=\"translate(-17.000000, -16.000000)\" fill=\"currentColor\" fill-rule=\"nonzero\">\n          <path d=\"M39.7170667,23.98025 L41.3802667,22.0206 C42.31325,22.9163667 43.1179,23.9391833 43.7788167,25.0608167 L41.4996167,26.2556 C40.9991167,25.424 40.4049333,24.6565667 39.7170667,23.98025 Z M44.6502,26.7766333 L42.3568833,27.9791167 C42.6841333,28.8094333 42.9151333,29.68595 43.0409,30.5958333 L45.6345167,30.5958333 C45.4843667,29.2573167 45.1494167,27.9752667 44.6502,26.7766333 L44.6502,26.7766333 Z M25.6440333,22.3363 C27.3868,21.2711333 29.4273,20.65 31.6166667,20.65 C34.0793833,20.65 36.3585833,21.4302667 38.2348167,22.7495333 L39.9005833,20.7873167 C37.5726167,19.0946 34.7159167,18.0833333 31.6166667,18.0833333 C28.8818833,18.0833333 26.3473,18.8841333 24.18745,20.23035 L21.8132833,16.8 L19.05155,25.7833333 L28.0271833,25.7833333 L25.6440333,22.3363 L25.6440333,22.3363 Z M43.1512667,32.5208333 C43.1166167,33.7554 42.8869,34.9399167 42.4916333,36.05 L45.1879167,36.05 C45.5074667,34.9232333 45.7025333,33.7425667 45.7333333,32.5208333 L43.1512667,32.5208333 Z M23.5162667,40.41975 L21.85435,42.3794 C20.9213667,41.4836333 20.1154333,40.4608167 19.4558,39.3391833 L21.7337167,38.1444 C22.2342167,38.976 22.8284,39.7434333 23.5162667,40.41975 L23.5162667,40.41975 Z M18.5831333,37.6233667 L20.87645,36.4208833 C20.5504833,35.5905667 20.3194833,34.71405 20.1924333,33.8041667 L17.5975333,33.8041667 C17.75025,35.1426833 18.0839167,36.4247333 18.5831333,37.6233667 Z M37.5893,42.0637 C35.8478167,43.1288667 33.8073167,43.75 31.6166667,43.75 C29.1552333,43.75 26.87475,42.9697333 24.9998,41.6504667 L23.33275,43.6126833 C25.6607167,45.3054 28.5187,46.3166667 31.6166667,46.3166667 C34.35145,46.3166667 36.8873167,45.5158667 39.0458833,44.16965 L41.42005,47.6 L44.1817833,38.6166667 L35.20615,38.6166667 L37.5893,42.0637 L37.5893,42.0637 Z M20.0820667,31.8791667 C20.1167167,30.6446 20.3477167,29.4600833 20.7404167,28.35 L18.0454167,28.35 C17.7258667,29.4767667 17.5295167,30.6574333 17.5,31.8791667 L20.0820667,31.8791667 Z\" id=\"Shape\" transform=\"translate(31.616667, 32.200000) scale(-1, 1) translate(-31.616667, -32.200000) \"></path>\n        </g>\n      </g>\n    </svg>\n    <!-- Failed -->\n    <svg viewBox=\"0 0 28 27\" *ngIf=\"icon === 'failed'\">\n      <g id=\"Page-1\" stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <g id=\"Artboard-Copy-3\" transform=\"translate(-18.000000, -18.000000)\" fill=\"currentColor\" fill-rule=\"nonzero\">\n          <path d=\"M32.1000157,45.0000026 C39.3875244,45.0000026 45.3000315,39.0874956 45.3000315,31.7999869 C45.3000315,24.5124782 39.3875244,18.5999712 32.1000157,18.5999712 C24.812507,18.5999712 18.9,24.5124782 18.9,31.7999869 C18.9,39.0874956 24.812507,45.0000026 32.1000157,45.0000026 Z M33.6812676,34.5499902 L30.5015763,34.5499902 C30.1750134,34.5499902 29.9172006,34.3609274 29.9172006,34.1203022 L29.6250128,23.4468519 C29.6250128,23.3265393 29.6765753,23.2062266 29.796888,23.1374766 C29.9000131,23.051539 30.0547008,22.9999764 30.2093885,22.9999764 L33.990643,22.9999764 C34.1453307,22.9999764 34.3000184,23.051539 34.4031435,23.1374766 C34.5234561,23.2062266 34.5750187,23.3265393 34.5750187,23.4468519 L34.2656433,34.1203022 C34.2484558,34.3609274 33.990643,34.5499902 33.6812676,34.5499902 Z M33.7672052,40.5999974 L30.4672013,40.5999974 C30.1578259,40.5999974 29.9000131,40.3421846 29.9000131,40.0328092 L29.9000131,36.7671803 C29.9000131,36.4578049 30.1578259,36.1999921 30.4672013,36.1999921 L33.7672052,36.1999921 C34.0593931,36.1999921 34.3000184,36.4578049 34.3000184,36.7671803 L34.3000184,40.0328092 C34.3000184,40.3421846 34.0593931,40.5999974 33.7672052,40.5999974 Z\" id=\"\uF06A\"></path>\n        </g>\n      </g>\n    </svg>\n    <!-- Success -->\n    <svg viewBox=\"0 0 31 31\" *ngIf=\"icon === 'success'\">\n      <g id=\"Page-1\" stroke=\"none\" stroke-width=\"1\" fill=\"none\" fill-rule=\"evenodd\">\n        <g id=\"Artboard-Copy-4\" transform=\"translate(-17.000000, -17.000000)\" fill=\"currentColor\" fill-rule=\"nonzero\">\n          <path d=\"M24.9403042,28.1887417 C25.5036875,27.6253583 26.1286708,27.1607917 26.7934375,26.7937583 C30.4984208,24.751975 35.2493208,25.837675 37.6311875,29.448975 L34.7488208,32.3300583 C33.9223542,30.4448417 31.8703042,29.371975 29.8285208,29.8288417 C29.0598042,30.0008083 28.3295875,30.384525 27.7328375,30.981275 L22.2093708,36.5073083 C20.5320542,38.184625 20.5320542,40.9129917 22.2093708,42.5903083 C23.8866875,44.267625 26.6150542,44.267625 28.2923708,42.5903083 L29.9953542,40.887325 C31.5443375,41.5020417 33.2049708,41.7471583 34.8450708,41.6252417 L31.0861875,45.384125 C27.8637375,48.606575 22.6392875,48.606575 19.4168375,45.384125 C16.1943875,42.161675 16.1943875,36.937225 19.4168375,33.714775 L24.9403042,28.1887417 Z M33.7131708,19.415875 L29.9542875,23.1747583 C31.5931042,23.0515583 33.2550208,23.2979583 34.8040042,23.9113917 L36.5057042,22.2096917 C38.1830208,20.532375 40.9113875,20.532375 42.5887042,22.2096917 C44.2660208,23.8870083 44.2660208,26.615375 42.5887042,28.2926917 L37.0639542,33.8174417 C35.3815042,35.4998917 32.6492875,35.485775 30.9809542,33.8174417 C30.5921042,33.4285917 30.2571542,32.944775 30.0479708,32.4686583 L27.1656042,35.3497417 C27.4684708,35.809175 27.7828875,36.205725 28.1871375,36.609975 C29.2292042,37.6520417 30.5561708,38.4284583 32.0833375,38.796775 C34.0622375,39.2728917 36.1823042,39.0098083 38.0033542,38.0049583 C38.6681208,37.637925 39.2931042,37.1733583 39.8564875,36.609975 L45.3799542,31.085225 C48.6036875,27.862775 48.6036875,22.638325 45.3812375,19.415875 C42.1587875,16.1947083 36.9356208,16.1947083 33.7131708,19.415875 Z\" id=\"Shape-Copy\"></path>\n        </g>\n      </g>\n    </svg>\n  </div>\n  <div class=\"flex-item-middle m-l-16\">\n    <p class=\"text-label-small\" translate>Connection status</p>\n    <h4 class=\"m-t-4 m-b-8\" [ngClass]=\"{ 'text-muted': icon === 'unknown' }\">{{ statusName | translate }}</h4>\n    <p><strong>{{ baseUrl }}</strong></p>\n  </div>\n</div>\n"
                },] }
    ];
    StatusDisplayComponent.propDecorators = {
        baseUrl: [{ type: core.Input }],
        status: [{ type: core.Input }]
    };

    var impactRoutes = [
        {
            path: 'connectivitySettings/impact_provider_settings',
            component: ImpactProviderSettingsComponent,
            canActivate: [ImpactGuard]
        }
    ];
    var ImpactModule = /** @class */ (function () {
        function ImpactModule() {
        }
        return ImpactModule;
    }());
    ImpactModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [ImpactProviderSettingsComponent, StatusDisplayComponent],
                    exports: [ImpactProviderSettingsComponent],
                    imports: [
                        ngxComponents.CoreModule,
                        ngxComponents.CommonModule,
                        ngxComponents.FormsModule,
                        router.RouterModule.forChild(impactRoutes),
                        popover.PopoverModule,
                        forms.ReactiveFormsModule
                    ],
                    entryComponents: [ImpactProviderSettingsComponent],
                    providers: [
                        ImpactConnectivityService,
                        ImpactGuard,
                        ImpactTabFactory,
                        {
                            provide: ngxComponents.HOOK_NAVIGATOR_NODES,
                            useClass: ImpactNodeFactory,
                            multi: true
                        },
                        {
                            provide: ngxComponents.HOOK_TABS,
                            useClass: ImpactTabFactory,
                            multi: true
                        }
                    ]
                },] }
    ];

    var SigfoxGuard = /** @class */ (function () {
        function SigfoxGuard(applicationService) {
            this.applicationService = applicationService;
        }
        SigfoxGuard.prototype.canActivate = function (route, state) {
            if (this.showSigfoxProvider === undefined) {
                this.showSigfoxProvider = this.applicationService
                    .isAvailable(SigfoxGuard.applicationName)
                    .then(function (result) { return result && result.data; });
            }
            return this.showSigfoxProvider;
        };
        return SigfoxGuard;
    }());
    SigfoxGuard.applicationName = 'sigfox-agent';
    SigfoxGuard.decorators = [
        { type: core.Injectable }
    ];
    SigfoxGuard.ctorParameters = function () { return [
        { type: client.ApplicationService }
    ]; };

    var SigfoxTabFactory = /** @class */ (function (_super) {
        __extends(SigfoxTabFactory, _super);
        function SigfoxTabFactory(router, guard) {
            var _this = _super.call(this, router, guard) || this;
            _this.router = router;
            _this.guard = guard;
            _this.tabConfig = {
                label: ngxComponents.gettext('Sigfox provider settings'),
                path: '/connectivitySettings/sigfox_provider_settings',
                icon: 'c8y-device'
            };
            return _this;
        }
        SigfoxTabFactory.prototype.config = function () {
            return this.tabConfig;
        };
        return SigfoxTabFactory;
    }(AbstractConnectivityTabFactory));
    SigfoxTabFactory.decorators = [
        { type: core.Injectable }
    ];
    SigfoxTabFactory.ctorParameters = function () { return [
        { type: router.Router },
        { type: SigfoxGuard }
    ]; };

    var SigfoxNodeFactory = /** @class */ (function (_super) {
        __extends(SigfoxNodeFactory, _super);
        function SigfoxNodeFactory(tabFactory) {
            var _this = _super.call(this, tabFactory) || this;
            _this.tabFactory = tabFactory;
            return _this;
        }
        return SigfoxNodeFactory;
    }(AbstractConnectivityNodeFactory));
    SigfoxNodeFactory.decorators = [
        { type: core.Injectable }
    ];
    SigfoxNodeFactory.ctorParameters = function () { return [
        { type: SigfoxTabFactory }
    ]; };

    var SigfoxModule = /** @class */ (function () {
        function SigfoxModule() {
        }
        return SigfoxModule;
    }());
    SigfoxModule.decorators = [
        { type: core.NgModule, args: [{
                    providers: [
                        SigfoxGuard,
                        SigfoxTabFactory,
                        {
                            provide: ngxComponents.HOOK_NAVIGATOR_NODES,
                            useClass: SigfoxNodeFactory,
                            multi: true
                        },
                        {
                            provide: ngxComponents.HOOK_TABS,
                            useClass: SigfoxTabFactory,
                            multi: true
                        }
                    ]
                },] }
    ];

    var connectivityRoutes = [
        {
            path: 'connectivitySettings',
            component: ngxComponents.ConditionalTabsOutletComponent
        }
    ];
    var ConnectivityModule = /** @class */ (function () {
        function ConnectivityModule() {
        }
        return ConnectivityModule;
    }());
    ConnectivityModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        ngxComponents.CoreModule,
                        ActilityModule,
                        ImpactModule,
                        SigfoxModule,
                        router.RouterModule.forChild(connectivityRoutes)
                    ]
                },] }
    ];

    var SimGuard = /** @class */ (function () {
        function SimGuard(permissions, applicationService) {
            this.permissions = permissions;
            this.applicationService = applicationService;
        }
        SimGuard.prototype.canActivate = function (route, state) {
            var _this = this;
            if (this.showSimProvider === undefined) {
                var hasRole = Promise.resolve(this.permissions.hasRole('ROLE_CONNECTIVITY_READ'));
                this.showSimProvider = hasRole.then(function (hasPermissions) { return hasPermissions &&
                    _this.applicationService
                        .isAvailable(SimGuard.applicationName)
                        .then(function (result) { return result && result.data; }); });
            }
            return this.showSimProvider;
        };
        return SimGuard;
    }());
    SimGuard.applicationName = 'connectivity';
    SimGuard.decorators = [
        { type: core.Injectable }
    ];
    SimGuard.ctorParameters = function () { return [
        { type: ngxComponents.Permissions },
        { type: client.ApplicationService }
    ]; };

    function encodeFiles(model, fields) {
        return __awaiter(this, void 0, void 0, function () {
            var result, fileFields, fileFields_1, fileFields_1_1, fileField, files, _a, _b, encodedFileContent, files_1, files_1_1, file, _c, _d, e_1_1, e_2_1;
            var e_2, _e, e_1, _f;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        result = Object.assign({}, model);
                        fileFields = (lodashEs.get(fields, '[0].fieldGroup') || []).filter(function (field) {
                            return field.type === 'file' && field.templateOptions.contentEncoding === 'base64';
                        });
                        _g.label = 1;
                    case 1:
                        _g.trys.push([1, 17, 18, 19]);
                        fileFields_1 = __values(fileFields), fileFields_1_1 = fileFields_1.next();
                        _g.label = 2;
                    case 2:
                        if (!!fileFields_1_1.done) return [3 /*break*/, 16];
                        fileField = fileFields_1_1.value;
                        files = model[fileField.key];
                        if (!(files && Array.isArray(files) && files.length)) return [3 /*break*/, 14];
                        if (!(fileField.templateOptions.maxAllowedFiles === 1)) return [3 /*break*/, 4];
                        _a = result;
                        _b = fileField.key;
                        return [4 /*yield*/, files[0].readAsDataURL()];
                    case 3:
                        _a[_b] = (_g.sent()).replace(/data:\S+;base64,/gi, '');
                        return [3 /*break*/, 13];
                    case 4:
                        encodedFileContent = [];
                        _g.label = 5;
                    case 5:
                        _g.trys.push([5, 10, 11, 12]);
                        files_1 = (e_1 = void 0, __values(files)), files_1_1 = files_1.next();
                        _g.label = 6;
                    case 6:
                        if (!!files_1_1.done) return [3 /*break*/, 9];
                        file = files_1_1.value;
                        _d = (_c = encodedFileContent).push;
                        return [4 /*yield*/, file.readAsDataURL()];
                    case 7:
                        _d.apply(_c, [(_g.sent()).replace(/data:\S+;base64,/gi, '')]);
                        _g.label = 8;
                    case 8:
                        files_1_1 = files_1.next();
                        return [3 /*break*/, 6];
                    case 9: return [3 /*break*/, 12];
                    case 10:
                        e_1_1 = _g.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 12];
                    case 11:
                        try {
                            if (files_1_1 && !files_1_1.done && (_f = files_1.return)) _f.call(files_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 12:
                        result[fileField.key] = encodedFileContent;
                        _g.label = 13;
                    case 13: return [3 /*break*/, 15];
                    case 14:
                        if (typeof files === 'string' || files instanceof String) {
                            result[fileField.key] = files;
                        }
                        _g.label = 15;
                    case 15:
                        fileFields_1_1 = fileFields_1.next();
                        return [3 /*break*/, 2];
                    case 16: return [3 /*break*/, 19];
                    case 17:
                        e_2_1 = _g.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 19];
                    case 18:
                        try {
                            if (fileFields_1_1 && !fileFields_1_1.done && (_e = fileFields_1.return)) _e.call(fileFields_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 19: return [2 /*return*/, result];
                }
            });
        });
    }
    var SimModule = /** @class */ (function () {
        function SimModule() {
        }
        return SimModule;
    }());
    SimModule.decorators = [
        { type: core.NgModule, args: [{
                    providers: [SimGuard],
                    imports: [
                        ngxComponents.ProviderConfigurationModule.config([
                            {
                                navigation: {
                                    label: ngxComponents.gettext('Connectivity'),
                                    path: 'connectivitySettings',
                                    icon: 'plug',
                                    parent: ngxComponents.gettext('Settings'),
                                    priority: 1000,
                                    preventDuplicates: true
                                },
                                tab: {
                                    path: 'sim_provider_settings',
                                    label: 'SIM provider settings',
                                    icon: 'mobile',
                                    canActivate: [SimGuard]
                                },
                                layout: {
                                    pageTitle: ngxComponents.gettext('Connectivity'),
                                    cardTitle: ngxComponents.gettext('Settings'),
                                    description: ngxComponents.gettext("In order to see the 'Connectivity' tab in device details, the user needs to have 'Read' permission for 'Connectivity'. To change SIM card status and send text messages, the user needs to have 'Admin' permission for 'Connectivity'."),
                                    providerName: ngxComponents.gettext('Provider'),
                                    providerNamePlaceholder: ngxComponents.gettext('Select or type to filter providers'),
                                    providerNameNoMatchesHint: ngxComponents.gettext('Select one of the existing providers.'),
                                    deleteRoles: ['ROLE_CONNECTIVITY_ADMIN'],
                                    deleteBtnLabel: ngxComponents.gettext('Delete'),
                                    saveRoles: ['ROLE_CONNECTIVITY_ADMIN'],
                                    saveBtnLabel: ngxComponents.gettext('Save'),
                                    beforeSaveHook: encodeFiles,
                                    configurationUpdatedSuccessMsg: ngxComponents.gettext('Settings updated.'),
                                    deleteConfigurationModalTitle: ngxComponents.gettext('Delete settings'),
                                    deleteConfigurationModalBody: ngxComponents.gettext("You are about to delete SIM provider settings. Do you want to proceed?"),
                                    deleteConfigurationModalOkBtnLabel: ngxComponents.gettext('Delete'),
                                    configurationDeletedSuccessMsg: ngxComponents.gettext('Settings deleted.')
                                },
                                endpoint: {
                                    definitionsEndpoint: {
                                        baseUrl: 'service/connectivity/metadata',
                                        listUrl: 'definitions'
                                    },
                                    configurationEndpoint: {
                                        baseUrl: 'service/connectivity/metadata',
                                        listUrl: 'sim/provider'
                                    }
                                }
                            }
                        ])
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AbstractConnectivityNodeFactory = AbstractConnectivityNodeFactory;
    exports.AbstractConnectivityTabFactory = AbstractConnectivityTabFactory;
    exports.ActilityGuard = ActilityGuard;
    exports.ActilityModule = ActilityModule;
    exports.ActilityNodeFactory = ActilityNodeFactory;
    exports.ActilityTabFactory = ActilityTabFactory;
    exports.ConnectivityModule = ConnectivityModule;
    exports.ImpactConnectivityService = ImpactConnectivityService;
    exports.ImpactGuard = ImpactGuard;
    exports.ImpactModule = ImpactModule;
    exports.ImpactNodeFactory = ImpactNodeFactory;
    exports.ImpactProviderSettingsComponent = ImpactProviderSettingsComponent;
    exports.ImpactTabFactory = ImpactTabFactory;
    exports.SigfoxGuard = SigfoxGuard;
    exports.SigfoxModule = SigfoxModule;
    exports.SigfoxNodeFactory = SigfoxNodeFactory;
    exports.SigfoxTabFactory = SigfoxTabFactory;
    exports.SimGuard = SimGuard;
    exports.SimModule = SimModule;
    exports.StatusDisplayComponent = StatusDisplayComponent;
    exports.encodeFiles = encodeFiles;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=c8y-ngx-components-connectivity.umd.js.map
