(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@c8y/ngx-components'), require('@c8y/client')) :
    typeof define === 'function' && define.amd ? define('@c8y/ngx-components/operations/operation-summary', ['exports', '@angular/core', '@c8y/ngx-components', '@c8y/client'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.c8y = global.c8y || {}, global.c8y["ngx-components"] = global.c8y["ngx-components"] || {}, global.c8y["ngx-components"].operations = global.c8y["ngx-components"].operations || {}, global.c8y["ngx-components"].operations["operation-summary"] = {}), global.ng.core, global.c8y["ngx-components"], global.client));
})(this, (function (exports, core, ngxComponents, client) { 'use strict';

    var OperationSummaryComponent = /** @class */ (function () {
        function OperationSummaryComponent(inventoryService) {
            this.inventoryService = inventoryService;
            this.deviceCount = 0;
            this.displayDeviceCount = false;
        }
        Object.defineProperty(OperationSummaryComponent.prototype, "deviceQueryString", {
            set: function (query) {
                var _this = this;
                this.displayDeviceCount = true;
                var filters = {
                    q: query || '',
                    pageSize: 1,
                    currentPage: 1,
                    withTotalPages: true
                };
                this.inventoryService
                    .list(filters)
                    .then(function (result) { return (_this.deviceCount = result.paging.totalPages); });
            },
            enumerable: false,
            configurable: true
        });
        return OperationSummaryComponent;
    }());
    OperationSummaryComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'c8y-operation-summary',
                    template: "<div class=\"row\">\n  <div class=\"col-md-12 text-center\">\n    <p>{{ name | translate }}</p>\n    <div class=\"row\">\n      <div class=\"col-md-4 col-md-offset-4 text-center\">\n        <h4 class=\"m-t-16 m-b-8 text-truncate\" title=\"{{ description | translate }}\">{{ description | translate }}</h4>\n      </div>\n    </div>\n    <span\n      class=\"text-muted\"\n      [ngPlural]=\"deviceCount\"\n      *ngIf=\"displayDeviceCount && deviceCount !== undefined && deviceCount !== null\"\n    >\n      <ng-template ngPluralCase=\"=0\">\n        <span translate>No devices selected</span>\n      </ng-template>\n      <ng-template ngPluralCase=\"=1\">\n        <span translate>1 device selected</span>\n      </ng-template>\n      <ng-template ngPluralCase=\"other\">\n        <span translate ngNonBindable [translateParams]=\"{ deviceCount: deviceCount }\">\n          {{ deviceCount }} devices selected</span\n        >\n      </ng-template>\n    </span>\n  </div>\n</div>\n"
                },] }
    ];
    OperationSummaryComponent.ctorParameters = function () { return [
        { type: client.InventoryService }
    ]; };
    OperationSummaryComponent.propDecorators = {
        name: [{ type: core.Input }],
        description: [{ type: core.Input }],
        deviceQueryString: [{ type: core.Input }]
    };

    /**
     * This module provides a component for displaying the summary of given bulk operation.
     */
    var OperationSummaryModule = /** @class */ (function () {
        function OperationSummaryModule() {
        }
        return OperationSummaryModule;
    }());
    OperationSummaryModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [ngxComponents.CoreModule],
                    declarations: [OperationSummaryComponent],
                    entryComponents: [OperationSummaryComponent],
                    exports: [OperationSummaryComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.OperationSummaryComponent = OperationSummaryComponent;
    exports.OperationSummaryModule = OperationSummaryModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=c8y-ngx-components-operations-operation-summary.umd.js.map
