import { InjectionToken } from '@angular/core';
import { Widget } from '@c8y/ngx-components';
/**
 * A hook to define the default widgets of the home dashboard in the cockpit app.
 */
export declare const COCKPIT_HOME_DASHBOARD_CONFIG: InjectionToken<unknown>;
export interface CockpitDashboardConfig {
    /**
     * Allows to have customized dashboard context name in case the CockpitDashboardModule is used in different apps and should have individual home dashboards per app
     */
    dashboardName?: string;
    /**
     * Allows to define the default widgets shown on the Cockpit Home page
     */
    defaultWidgets?: Widget[];
    /**
     * Allows to have a different page title than the default 'Home'
     */
    pageTitle?: string;
    /**
     * Allows to have individual home dashboards per user
     */
    userSpecific?: boolean;
}
/**
 * An array of widgets that is per default placed on the home dashboard of the cockpit app.
 */
export declare const DEFAULT_COCKPIT_HOME_WIDGETS: Widget[];
