import { NavigatorService, NavigatorNode, Permissions } from '@c8y/ngx-components';
import { BsModalRef } from 'ngx-bootstrap/modal';
import { ContextDashboard } from './context-dashboard.model';
import { ContextDashboardService } from './context-dashboard.service';
import { NgForm } from '@angular/forms';
import { Observable } from 'rxjs';
import { TranslateService } from '@ngx-translate/core';
export declare class DashboardDetailComponent {
    private modal;
    private contextDashboardService;
    private navigatorService;
    private permissionsService;
    private translateService;
    dashboardDetailForm: NgForm;
    dashboard: ContextDashboard;
    current: ContextDashboard;
    isReport: boolean;
    deviceType: string;
    isNamedDashboard: boolean;
    isDeviceType: boolean;
    icons: string[];
    filteredIcons: string[];
    styling: {
        themeClass: string;
        headerClass: string;
    };
    possibleStyling: {
        DASHBOARD_THEME_CLASSES: {
            label: any;
            class: string;
            description: any;
        }[];
        WIDGET_HEADER_CLASSES: {
            label: any;
            class: string;
            description: any;
        }[];
    };
    titleName: string;
    namePlaceholder: string;
    titleAction: string;
    navigatorNodes$: Observable<NavigatorNode[]>;
    result: Promise<ContextDashboard>;
    applyToDevicesOfTypePermitted: boolean;
    get applyToDevicesOfTypeTitle(): string;
    readonly DEFAULT_DASHBOARD_MARGIN = 12;
    readonly DEFAULT_DASHBOARD_ICON = "th";
    readonly DEFAULT_DASHBOARD_PRIORITY = 10000;
    private _save;
    private _cancel;
    constructor(modal: BsModalRef, iconList: string[], contextDashboardService: ContextDashboardService, navigatorService: NavigatorService, permissionsService: Permissions, translateService: TranslateService);
    ngAfterContentInit(): void;
    setTitle(): void;
    setupApplyToDevicesOfTypeCheckbox(): void;
    save(): void;
    close(): void;
    getDashboardPreviewStyle(): {};
    selectIcon(icon: any): void;
    updateFiltered(term: string): void;
    private setDashboardStyle;
}
