import { BehaviorSubject, Observable } from 'rxjs';
import { BsModalService } from 'ngx-bootstrap/modal';
import { IManagedObject, InventoryService, IResultList } from '@c8y/client';
import { FilterInputComponent, ModalService, AlertService } from '@c8y/ngx-components';
import { ContextDashboardService } from '../context-dashboard.service';
import { TranslateService } from '@ngx-translate/core';
import { ReportDashboardService } from './report-dashboard.service';
export declare class ReportDashboardListComponent {
    private inventoryService;
    private contextDashboardService;
    private bsModal;
    private translateService;
    private modal;
    private alertService;
    private reportDashboardService;
    filter: FilterInputComponent;
    textFilter$: BehaviorSubject<string>;
    reload$: BehaviorSubject<void>;
    reloading: boolean;
    reports$: Observable<IResultList<IManagedObject>>;
    private readonly DELETED_SUCCESS_MSG;
    constructor(inventoryService: InventoryService, contextDashboardService: ContextDashboardService, bsModal: BsModalService, translateService: TranslateService, modal: ModalService, alertService: AlertService, reportDashboardService: ReportDashboardService);
    loadReports(partialName?: string): Promise<IResultList<IManagedObject>>;
    add(): Promise<void>;
    delete(report: IManagedObject): Promise<void>;
    update(report: IManagedObject): Promise<void>;
}
