import { OnDestroy } from '@angular/core';
import { DynamicComponentDefinition, Widget, DynamicComponentComponent } from '@c8y/ngx-components';
import { BsModalRef } from 'ngx-bootstrap/modal';
import { Subject } from 'rxjs';
import { ContextDashboardManagedObject, ContextWidgetConfig } from './context-dashboard.model';
import { WidgetService } from './widget.service';
import { ContextDashboardService } from './context-dashboard.service';
export declare class WidgetConfigComponent implements OnDestroy {
    private widgetService;
    private modal;
    contextDashboardService: ContextDashboardService;
    mode: 'config' | 'select' | 'style';
    searchResult: DynamicComponentDefinition[];
    components: DynamicComponentDefinition[];
    selected: DynamicComponentDefinition;
    searchChange$: Subject<unknown>;
    searchTerm: string;
    context: any;
    componentLabel: string;
    mo: ContextDashboardManagedObject;
    styling: {
        headerClass: string;
        contentClass: string;
    };
    defaultStyling: {
        headerClass: string;
        contentClass: string;
    };
    possibleStyling: {
        WIDGET_HEADER_CLASSES: {
            label: any;
            class: string;
            description: any;
        }[];
        WIDGET_CONTENT_CLASSES: {
            label: any;
            class: string;
            description: any;
        }[];
    };
    current: any;
    widgetConfig: ContextWidgetConfig;
    isUpgrade: boolean;
    dynamicComponent: DynamicComponentComponent;
    get isEdit(): boolean;
    result: Promise<Widget>;
    private searchSub;
    private _save;
    private _cancel;
    constructor(widgetService: WidgetService, modal: BsModalRef, contextDashboardService: ContextDashboardService);
    ngAfterContentInit(): void;
    save(): Promise<void>;
    select(cmp: any, mode?: 'select' | 'config'): void;
    search(): void;
    resetSearch(): void;
    changeMode(mode: 'config' | 'select' | 'style'): void;
    close(): void;
    getStyle(isPreview?: boolean): {};
    ngOnDestroy(): void;
    private isDashboardDefaultStyle;
    private setDefaultStyle;
    private composeWidgetConfig;
    private applyTargetIfDeviceDashboard;
}
