import { ExtensionFactory } from '../common/extension-hooks';
/**
 * An action bar item is a action in scope of a
 * current route of the application.
 */
export interface ActionBarItem {
    /**
     * Angular template used for Content Projection
     */
    template: any;
    /**
     * Ordering of the actions (high number first)
     */
    priority: number;
    /**
     * The placement of the item. `more` is a dropdown
     * on the right side.
     */
    placement: 'left' | 'right' | 'more';
}
/**
 * Factory to implement if used in a hook for Multi Provider extension.
 */
export declare type ActionBarFactory = ExtensionFactory<ActionBarItem>;
