import { Action } from './action.model';
/**
 * This component is used as the outlet to show the action list.
 * In a c8ycli app it is by default placed on the header component near app-switcher.
 */
export declare class ActionOutletComponent {
    /**
     * Identifies if in a mobile view the toolbar is expanded or not.
     */
    isPageToolbarExpanded: boolean;
    /**
     * The current items to display in the action dropdown.
     */
    items: Action[];
    /**
     * Returns the items ordered by priority.
     */
    getByPriority(): any;
    /**
     * Invokes action after an action is clicked.
     */
    invoke(action: any): void;
    private byPriority;
}
