import { ExtensionFactory } from '../common/extension-hooks';
/**
 * An action is a global operation which you can
 * add to the plus sign in the upper right corner
 */
export interface Action {
    /**
     * Angular template used for Content Projection (optional)
     */
    template?: any;
    /**
     * Ordering of the actions (high number first) (optional)
     */
    priority?: number;
    /**
     * Is that action disabled.
     */
    disabled?: boolean;
    /**
     * The label of the component (optional)
     */
    label: string;
    /**
     * The icon to show on this action (optional)
     */
    icon?: string;
    /**
     * Which action to trigger on click (optional)
     */
    action?: (...args: any[]) => void;
}
/**
 * Factory to implement if used in a hook for Multi Provider extension.
 */
export declare type ActionFactory = ExtensionFactory<Action>;
