import { TemplateRef } from '@angular/core';
/**
 * An alert is a message show to the user.
 */
export interface Alert {
    /**
     * The text to display.
     */
    text: string | TemplateRef<any>;
    /**
     * The type of the alert.
     */
    type: 'success' | 'warning' | 'danger' | 'info' | 'system';
    /**
     * Detailed information to display.
     */
    detailedData?: any;
    /**
     * Timeout to auto close
     */
    timeout?: number;
    /**
     * Allows to display alert's text as HTML.
     */
    allowHtml?: boolean;
    /**
     * Function to call if user clicks on the detail button.
     */
    onDetail?: () => void;
    /**
     * Function to call if user clicks on the close button.
     */
    onClose?: () => void;
}
