import { OnInit } from '@angular/core';
import { AuditService, IAuditRecord, IResultList } from '@c8y/client';
/**
 * Audit log component allows to show audits list. Component fetches audit records for the source object given as input.
 *
 * **Example**
 *
 * ```html
 *  <c8y-audit-log [source]="sourceId"></c8y-audit-log>
 * ```
 */
export declare class AuditLogComponent implements OnInit {
    private audit;
    /**
     * The source ID for which audits will be shown in the list.
     */
    source: string | number;
    /**
     * Audit records retrieved from auditRecords endpoint.
     */
    records: IResultList<IAuditRecord>;
    /**
     * @ignore
     */
    constructor(audit: AuditService);
    /**
     * After page view is initialized, component gets audit records from auditRecords endpoint.
     */
    ngOnInit(): Promise<void>;
}
