import { IdReference } from '@c8y/client';
/**
 * Realtime options for `ForOfDirective`.
 */
export interface ForOfRealtimeOptions {
    /** An entity object or id to be used with a [[RealtimeService]] instance. */
    entityOrId?: IdReference;
    /** Whether to insert an item which passes `pipe` but is not in the list yet (e.g. it didn't pass `pipe` on creation, but now it does). */
    insertOnUpdate?: boolean;
    /** Whether to remove an item which doesn't pass `pipe` but is in the list already (e.g. it passed `pipe` on creation, but now it doesn't). */
    removeOnUpdate?: boolean;
}
