import { OnChanges } from '@angular/core';
import { VirtualScrollWindowStrategy } from './virtual-scroll-window-strategy';
/**
 * Provider factory for `VirtualScrollWindowStrategy` that simply extracts the already created
 * `VirtualScrollWindowStrategy` from the given directive.
 * @param windowDir The instance of `VirtualScrollWindowDirective` to extract the
 *     `VirtualScrollWindowStrategy` from.
 */
export declare function _virtualScrollWindowStrategyFactory(windowDir: VirtualScrollWindowDirective): VirtualScrollWindowStrategy;
export declare class VirtualScrollWindowDirective implements OnChanges {
    /** The size of the items in the list (in pixels). */
    get itemSizePx(): number;
    set itemSizePx(value: number);
    _itemSizePx: number;
    /**
     * The minimum amount of buffer rendered beyond the viewport (in pixels).
     * If the amount of buffer dips below this number, more items will be rendered. Defaults to 100px.
     */
    get minBufferPx(): number;
    set minBufferPx(value: number);
    _minBufferPx: number;
    /**
     * The number of pixels worth of buffer to render for when rendering new items. Defaults to 200px.
     */
    get maxBufferPx(): number;
    set maxBufferPx(value: number);
    _maxBufferPx: number;
    /** The size of the offset (in pixels). */
    get offsetSizePx(): number;
    set offsetSizePx(value: number);
    _offsetSizePx: number;
    /** The scroll strategy used by this directive. */
    _scrollStrategy: VirtualScrollWindowStrategy;
    ngOnChanges(): void;
}
