import { Observable } from 'rxjs';
export declare class ZipService {
    getEntries(zipFile: File): Observable<ZipEntry[]>;
    getData(entry: ZipEntry): Observable<Blob>;
    getJsonData(zipFile: File, fileEntryFilter: {
        filename: string;
    }): Observable<string>;
}
export interface ZipEntry {
    version: number;
    bitFlag: number;
    compressionMethod: number;
    lastModDateRaw: number;
    lastModDate: string;
    crc32: number;
    compressedSize: number;
    uncompressedSize: number;
    filenameLength: number;
    extraFieldLength: number;
    commentLength: number;
    directory: boolean;
    offset: 0;
    filename: string;
    comment: string;
}
