export declare enum SendStatus {
    AVAILABLE = "AVAILABLE",
    UNAVAILABLE = "UNAVAILABLE",
    UNKNOWN = "UNKNOWN",
    MAINTENANCE = "MAINTENANCE",
    NOT_MONITORED = "NOT_MONITORED"
}
export declare enum PushStatus {
    CONNECTED = "CONNECTED",
    DISCONNECTED = "DISCONNECTED",
    UNKNOWN = "UNKNOWN",
    MAINTENANCE = "MAINTENANCE"
}
export declare enum SendStatusLabels {
    AVAILABLE,
    NOT_MONITORED,
    UNAVAILABLE,
    UNKNOWN,
    MAINTENANCE
}
export declare enum PushStatusLabels {
    CONNECTED,
    DISCONNECTED,
    UNKNOWN,
    MAINTENANCE
}
export declare const deviceAvailabilityIconMap: {
    sendData: {
        AVAILABLE: {
            icon: string;
            class: string;
        };
        UNAVAILABLE: {
            icon: string;
            class: string;
        };
        UNKNOWN: {
            icon: string;
            class: string;
        };
        NOT_MONITORED: {
            icon: string;
            class: string;
        };
    };
    push: {
        CONNECTED: {
            icon: string;
            class: string;
        };
        DISCONNECTED: {
            icon: string;
            class: string;
        };
        UNKNOWN: {
            icon: string;
            class: string;
        };
        MAINTENANCE: {
            icon: string;
            class: string;
        };
    };
    device: {
        MAINTENANCE: {
            icon: string;
            class: string;
        };
    };
};
export declare const tooltips: {
    sendStatusConnected: (lastMessage: any, translateService: any) => any;
    sendStatusDisconnected: any;
    pushStatusConnected: any;
    pushStatusDisconnected: any;
    maintenance: any;
};
