import { OnInit, QueryList, ElementRef, Renderer2, OnDestroy, AfterViewInit } from '@angular/core';
import { GuideHrefDirective } from './guide-href.directive';
import { DocsService } from './docs.service';
export declare class GuideDocsComponent implements OnInit, AfterViewInit, OnDestroy {
    private docs;
    private el;
    private renderer;
    baseUrl: string;
    links: QueryList<GuideHrefDirective>;
    /**
     * Provides access to translate directive, so it is possible to adjust anchor html tags, after
     * content is translated.
     */
    translateDirective: any;
    private destroyed$;
    constructor(docs: DocsService, el: ElementRef, renderer: Renderer2);
    ngOnInit(): void;
    /**
     * After content is initialized we subscribe for translation events, then we are able to modify
     * anchor just as C8yGuideHrefDirective does.
     */
    ngAfterViewInit(): void;
    /**
     * Find and modify anchor elements
     */
    replaceAnchorAttributes(): void;
    /**
     * Recursive function, returns array of Anchor elements inside HTMLElement.
     */
    findGuideAnchors(el: HTMLElement): HTMLElement[];
    ngOnDestroy(): void;
}
