import { OnDestroy, TemplateRef } from '@angular/core';
import { RangeDirective } from './range.directive';
/**
 * An component which renders a range slider in Cumulocity layout. You need
 * to wrap the default range input in this component.
 *
 * Example:
 * ```
 * <c8y-range>
 *   <input id="range" type="range" min="0" max="100000" value="0" step="1">
 * </c8y-range>
 * ```
 */
export declare class RangeComponent implements OnDestroy {
    range: RangeDirective;
    rangeValue: TemplateRef<any>;
    left: string;
    value: string;
    changeEventListener: EventListener;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    setValue(): void;
}
