export interface ValidationRules {
    pattern?: RegExp;
    message?: string;
    maxLength?: number;
    minLength?: number;
}
export declare class ValidationPattern {
    static readonly messages: {
        deviceId: any;
        domain: any;
        email: any;
        emails: any;
        internationalPhoneNumber: any;
        loginAlias: any;
        max: any;
        min: any;
        opcuaBrowsePath: any;
        password: any;
        passwordConfirm: any;
        passwordStrength: any;
        phoneNumber: any;
        required: any;
        tenantId: any;
        urlSegment: any;
        user: any;
    };
    static readonly rules: {
        deviceId: {
            pattern: RegExp;
        };
        domain: {
            pattern: RegExp;
        };
        groupName: {
            maxLength: number;
        };
        hostname: {
            pattern: RegExp;
        };
        ip: {
            pattern: RegExp;
        };
        opcuaBrowsePath: {
            pattern: RegExp;
        };
        password: {
            pattern: RegExp;
        };
        phoneNumber: {
            pattern: RegExp;
        };
        tenantId: {
            pattern: RegExp;
        };
        user: {
            pattern: RegExp;
        };
        urlSegment: {
            pattern: RegExp;
        };
        loginAlias: {
            pattern: RegExp;
        };
    };
    static get(key: string): ValidationRules;
}
