import { EventEmitter, SimpleChanges } from '@angular/core';
import { CheckboxControlValueAccessor } from '@angular/forms';
import { ElementRef, Renderer2 } from '@angular/core';
/**
 * A component to display checkboxes in a c8y-li. Use it with content projection. It
 * can be used standalone or with an ngModel.
 *
 * @example
 * ```html
 * <c8y-li>
 *   <c8y-li-checkbox></c8y-li-checkbox>
 * </c8y-li>
 * ```
 */
export declare class ListItemCheckboxComponent extends CheckboxControlValueAccessor {
    private renderer;
    private elementRef;
    /**
     * Indicates if the checkbox is selected.
     */
    selected: boolean;
    /**
     * Indicates if the checkbox is disabled.
     */
    disabled: boolean;
    /**
     * An event emitted as soon as the checkbox is selected.
     */
    onSelect: EventEmitter<boolean>;
    constructor(renderer: Renderer2, elementRef: ElementRef);
    /**
     * @ignore
     */
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * Selects the checkbox.
     * @param value The value to pass.
     */
    select(value: any): void;
}
