/**
 * Display collapsed content on a list item. Can be
 * used for more detailed information. Use it with
 * content projection.
 *
 * @example
 * ```html
 * <c8y-li>
 *   <c8y-collapsed>
 *     <strong>I am only visible if extended</strong>
 *   </c8y-collapsed>
 * </c8y-li>
 * ```
 */
export declare class ListItemCollapseComponent {
    /**
     * The way how to toggle collapse state.
     * button (default) - additional button for toggle collapse state
     * row - toggling collapse state by clicking to entire row.
     */
    collapseWay: 'button' | 'row';
}
