/**
 * An icon to display on a list item. Use it with content projection.
 *
 * @example
 * ```html
 * <c8y-li>
 *   <c8y-li-icon="rocket"></c8y-li-icon>
 * </c8y-li>
 * ```
 */
export declare class ListItemIconComponent {
    /**
     * The icon name passed to the `c8yIcon` directive.
     */
    icon: string;
    /**
     * A status to change the color of the icon.
     */
    status?: 'statusOk' | 'statusUnknown' | 'statusAlert' | 'statusNok' | 'status critical' | 'status warning' | 'status minor' | 'status major';
}
