import { OnInit, EventEmitter } from '@angular/core';
import { LoginService } from './login.service';
import { ICredentials } from '@c8y/client';
import { AlertService } from '../alert/alert.service';
import { AppStateService } from '../common/ui-state.service';
import { LoginViews } from './login.model';
export declare class CredentialsComponent implements OnInit {
    loginService: LoginService;
    alert: AlertService;
    ui: AppStateService;
    onChangeView: EventEmitter<any>;
    LOGIN_VIEWS: typeof LoginViews;
    model: ICredentials;
    isLoading: boolean;
    showLoginForm: boolean;
    showBasicAuth: boolean;
    oauthOptions: any;
    private readonly PASSWORD_RESET_HEADER_NAME;
    private readonly NO_PHONE_HEADER_NAME;
    constructor(loginService: LoginService, alert: AlertService, ui: AppStateService);
    ngOnInit(): void;
    redirectToOauth(): void;
    /**
     * Allows to login into the application using basic auth.
     * If successful logged in the client is set in shared/cumulocity.service.ts
     */
    login(): Promise<void>;
    private handlePasswordReset;
    private handleTotpChallenge;
    private handleSmsChallenge;
    private handleNoPhoneNumberProvided;
}
