import { EventEmitter } from '@angular/core';
import { LoginViews } from './login.model';
import { FetchClient } from '@c8y/client';
import { AppStateService } from '../common/ui-state.service';
import { LoginService } from './login.service';
import { AlertService } from '../alert/alert.service';
import { TranslateService } from '@ngx-translate/core';
export declare class TenantIdSetupComponent {
    private client;
    private ui;
    private loginService;
    private alert;
    private translateService;
    onChangeView: EventEmitter<any>;
    LOGIN_VIEWS: typeof LoginViews;
    model: {
        tenant: string;
    };
    constructor(client: FetchClient, ui: AppStateService, loginService: LoginService, alert: AlertService, translateService: TranslateService);
    /**
     * Sets up login mode for particular tenant. In case of OAI-Secure will redirect user to tenant domain.
     */
    setupLoginMode(): Promise<void>;
    /**
     * Redirects to tenant domain when login mode contains domain.
     */
    redirectToCorrectDomain(): void;
}
