import { BsModalService } from 'ngx-bootstrap/modal';
import { StatusType } from '../common/status.model';
/**
 * Service to show a modal.
 */
export declare class ModalService {
    private modalService;
    constructor(modalService: BsModalService);
    /**
     * Shows a quick confirm message modal.
     * @param title The title of that modal.
     * @param body The text body to display.
     * @param status The status.
     * @param labels The labels to use. Default: { ok: 'Confirm', cancel: 'Cancel'}
     */
    confirm(title: string, body: string, status?: StatusType, labels?: any): Promise<boolean>;
    /**
     * Shows a quick acknowledge message modal.
     * @param title The title of that modal.
     * @param body The text body to display.
     * @param status The status.
     * @param acknowledgeLabel The label to use.
     */
    acknowledge(title: string, body: string, status?: StatusType, acknowledgeLabel?: string): Promise<boolean>;
    /**
     * Shows a quick logout confirmation modal.
     * @param body The text body to display. Default: 'You will be logged out to apply your changes. Do you want to proceed?'
     * @param status The status.
     * @param labels The labels to use. Default: { ok: 'Confirm and log out', cancel: 'Cancel' }
     */
    confirmLogout(body?: string, status?: StatusType, labels?: any): Promise<boolean>;
}
