export interface NavigatorNodeData {
    /**
     * Navigator node name.
     * @deprecated
     */
    name?: string;
    /**
     * Label to be displayed in the navigator node.
     */
    label?: string;
    /**
     * Position of the node in the navigator.
     */
    priority?: number;
    /**
     * The path to which the UI will be redirected after clicking navigator node.
     */
    path?: string;
    /**
     * Navigator node icon.
     */
    icon?: string;
    /**
     * Navigator node icon when expanded.
     */
    iconOpen?: string;
    /**
     * Navigator node parent node.
     */
    parent?: NavigatorNodeData | string;
    /**
     * Check if a duplicate node is present and ignore it.
     */
    preventDuplicates?: boolean;
    [key: string]: any;
}
