import { ApplicationRemotePlugins, IApplication, IIdentified } from '@c8y/client';
import { ApplicationService, FetchClient } from '@c8y/ngx-components/api';
declare type Application = IIdentified | IApplication | number | string;
declare type Package = Application;
export declare class PluginsService {
    private applicationService;
    private client;
    constructor(applicationService: ApplicationService, client: FetchClient);
    listPackages(): Promise<IApplication[]>;
    listVersions(forPackage: Package): Promise<any>;
    listInstalled(forApp: Application, flat?: boolean): Promise<any>;
    addByName(addTo: Application, pluginName: string): Promise<any>;
    removeByName(removeFrom: Application, pluginName: string): Promise<any>;
    add(addToApp: Application, fromPackage: Package, name: string): Promise<any>;
    remove(removeFromApp: Application, fromPackage: Package, name: string): Promise<any>;
    updateRemotesInCumulocityJson(app: IApplication, remotes: ApplicationRemotePlugins): Promise<{
        res: import("@c8y/client").IFetchResponse;
        data: any;
    }>;
    private addOrRemove;
    private storeCumulocityJson;
    private getCumulocityJsonFile;
    private getApplication;
}
export {};
