import { ActivatedRoute } from '@angular/router';
import { FetchClient, IIdentified, IResult, Service } from '@c8y/client';
import { ProviderProperties } from '../model/provider-properties.model';
export declare class ProviderConfigurationService extends Service<ProviderProperties> {
    private static readonly NO_DETAIL_ID;
    protected baseUrl: string;
    protected listUrl: string;
    constructor(client: FetchClient, activatedRoute: ActivatedRoute);
    detail(): Promise<IResult<ProviderProperties>>;
    update(entity: Partial<ProviderProperties>): Promise<IResult<ProviderProperties>>;
    delete(): Promise<IResult<null>>;
    /** There is a single provider configuration per tenant and detail URL is not needed */
    protected getDetailUrl(_: string | number | IIdentified): string;
}
