export interface RangeDisplay {
    /**
     * The minimum value of the range display (optional)
     * Default should be 0.
     */
    min?: number;
    /**
     * The maximum value of the range display (optional)
     * Default should be 100.
     */
    max?: number;
    /**
     * Target value of the measurement (optional)
     */
    target?: number;
    /**
     * Current value of the measurement (optional)
     */
    current?: number;
    /**
     * Current time of the measurement (optional)
     */
    time?: string;
    /**
     * Minimum value for the yellow range. (optional)
     */
    yellowRangeMin?: number;
    /**
     * Maximum value for the yellow range. (optional)
     */
    yellowRangeMax?: number;
    /**
     * Minimum value for the red range. (optional)
     */
    redRangeMin?: number;
    /**
     * Maximum value for the red range. (optional)
     */
    redRangeMax?: number;
    /**
     * Unit of the measurement. E.g. 'C'(optional)
     */
    unit?: string;
    /**
     * Determines the number of decimal places (optional)
     */
    fractionSize?: number;
    /**
     * Widget orientation. Can only be 'horizontal' or 'vertical'. (optional)
     */
    orientation?: 'horizontal' | 'vertical';
}
