import { Injector } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { ApiService, ApiCall } from '@c8y/ngx-components/api';
import { Observable } from 'rxjs';
import { TabsService } from '../tabs/tabs.service';
import { RouterTabsResolver } from './router-tabs.resolver';
export declare class ContextRouteService {
    private tabsResolver;
    private tabsService;
    private router;
    private apiService;
    private injector;
    private dataSubscription;
    private routerSubscription;
    private lastAddedTabs;
    private refreshTrigger;
    constructor(tabsResolver: RouterTabsResolver, tabsService: TabsService, router: Router, apiService: ApiService, injector: Injector);
    init(route: ActivatedRoute): void;
    destroy(): void;
    refreshContext(): void;
    updatedContext(route: ActivatedRoute): Observable<ApiCall>;
    private updateTabs;
    private redirectToFirstTab;
    private needsRedirect;
    private getMatchingContextRoute;
}
