import { Route as ngRoute } from '@angular/router';
import { ExtensionFactory } from '../common/extension-hooks';
import { Tab } from '../tabs/tab.model';
export declare enum ViewContext {
    Device = "device/:id",
    Group = "group/:id",
    User = "users/:id",
    Application = "ecosystem/application/:id",
    Microservice = "microservices/:id",
    SubscribedApplications = "subscribedApplications/:id",
    Tenant = "tenants/:id",
    Report = "reports/:id"
}
export declare type Route = Partial<ngRoute> & {
    path: string;
    label?: string;
    icon?: string;
    context?: ViewContext;
    priority?: number;
    /**
     * Allow to emit multiple tabs on one context route.
     */
    tabs?: Tab[];
};
export declare type RouteFactory = Route | Route[] | ExtensionFactory<Route>;
