import { EventEmitter, SimpleChanges } from '@angular/core';
import { BsModalRef } from 'ngx-bootstrap/modal';
import { ISelectModalObject, ModalSelectionMode, ModalLabels } from './select-modal.model';
import { IIdentified } from '@c8y/client';
interface ISelectModalInternalObject extends ISelectModalObject {
    selectedId: string | number;
}
export declare class SelectModalComponent {
    private bsModalRef;
    icon: string;
    title: string;
    subTitle: string;
    items: ISelectModalInternalObject[];
    mode: ModalSelectionMode;
    disableSelected: boolean;
    showFilter: boolean;
    areMoreEntries: boolean;
    set labels(labels: ModalLabels);
    get labels(): ModalLabels;
    result: EventEmitter<IIdentified[]>;
    search: EventEmitter<string>;
    selected: boolean;
    filterTerm: string;
    listItems: any[];
    private debouncer;
    private _labels;
    constructor(bsModalRef: BsModalRef);
    ngOnChanges(changes: SimpleChanges): Promise<void>;
    updatePipe(filterTerm: string): void;
    updateChoice({ item, id }: {
        item: any;
        id: any;
    }): void;
    dismiss(): void;
    select(): void;
    ngOnDestroy(): void;
    private getOutput;
}
export {};
