import { EventEmitter, ElementRef, QueryList, AfterViewInit } from '@angular/core';
import { Validator, AbstractControl } from '@angular/forms';
import { IIdentified } from '@c8y/client';
import { BsDropdownDirective } from 'ngx-bootstrap/dropdown';
import { ListItemComponent } from '../list-group/list-item.component';
import { ControlValueAccessor } from '@angular/forms';
export declare class TypeaheadComponent implements ControlValueAccessor, Validator, AfterViewInit {
    searchControl: ElementRef;
    searchControlModel: any;
    dropdown: BsDropdownDirective;
    list: QueryList<ListItemComponent>;
    required: boolean;
    maxlength: string | number;
    disabled: boolean;
    allowFreeEntries: boolean;
    placeholder: string;
    displayProperty: string;
    icon: string;
    name: string;
    autoClose: boolean;
    container: '' | 'body';
    selected: IIdentified;
    onSearch: EventEmitter<string>;
    onIconClick: EventEmitter<string>;
    private subscription;
    private onChange;
    private onTouched;
    private readonly KEYCODE_UP;
    private readonly KEYCODE_DOWN;
    private readonly KEYCODE_TAB;
    private readonly KEYCODE_ENTER;
    private readonly KEYCODE_ESC;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    doBlur(): void;
    getDisplayProperty(): any;
    onShown(): void;
    /**
     * Resets the input field - clear value and clean field to be pristine and untouched.
     */
    reset(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    handleKeyboard(event: any): void;
    validate(ctrl: AbstractControl): {
        [key: string]: any;
    };
    private selectNextItemOnKeyboardMove;
}
