import { TemplateRef, EventEmitter } from '@angular/core';
import { StepState } from '@angular/cdk/stepper';
export declare class C8yStepperProgress {
    /** List of overriden icons as TemplateRef. Also default icons could be overriden.
     *  The given overriden icons will replace an icon with matching state: StepState
     *
     * <ng-container
     * *ngSwitchCase="true"
     * [ngTemplateOutlet]="iconOverrides[state]"
     * ></ng-container>
     *
     */
    iconOverrides: {
        [key: string]: TemplateRef<any>;
    };
    /** The index of the current step */
    index: number;
    /** Whether the step is cuurently selected or not  */
    selected: boolean;
    /** The current state of the step */
    state: StepState;
    /** Emits the index: number of the step which was clicked */
    onStepClicked: EventEmitter<number>;
    /** Called on click and emits the step index */
    stepSelected(): void;
}
