import { OnInit } from '@angular/core';
import { BasicAuth, FetchClient, IUser, UserService } from '@c8y/client';
import { BsModalRef, BsModalService } from 'ngx-bootstrap/modal';
import { AlertService } from '../alert/alert.service';
import { AppStateService } from '../common/ui-state.service';
import { UserPreferencesService } from '../common/user-preferences/user-preferences.service';
import { TranslateService } from '../i18n/translate.service';
import { ModalService } from '../modal/modal.service';
import { GainsightService } from '../product-experience/gainsight.service';
import { CookieBannerService } from '../bootstrap/cookie-banner/cookie-banner.service';
import { LoginService } from '../login/login.service';
export declare class UserEditModalComponent implements OnInit {
    modal: BsModalRef;
    user: UserService;
    ui: AppStateService;
    private auth;
    private client;
    private alert;
    private translate;
    private userPreferences;
    private modalService;
    private c8yModalService;
    private gainsightService;
    private cookieBannerService;
    private loginService;
    currentUser: IUser;
    lang: string;
    changedLang: string;
    loading: boolean;
    showProductUsageSetting: boolean;
    currentUsageTrackingState: boolean;
    usageTrackingState: boolean;
    constructor(modal: BsModalRef, user: UserService, ui: AppStateService, auth: BasicAuth, client: FetchClient, alert: AlertService, translate: TranslateService, userPreferences: UserPreferencesService, modalService: BsModalService, c8yModalService: ModalService, gainsightService: GainsightService, cookieBannerService: CookieBannerService, loginService: LoginService);
    ngOnInit(): Promise<void>;
    onDismiss(): void;
    onLanguage(lang: any): void;
    onProductExperience(option: boolean): void;
    updateAndClose(user: any): Promise<void>;
    persistLanguage(lang: any): Promise<boolean>;
    gainsightTrackingAppReload(): Promise<void>;
    private updateUserInAppState;
    private updateCredentials;
}
