import { EventEmitter, OnInit } from '@angular/core';
import { IUser, UserService, TenantLoginOptionsService, TenantService } from '@c8y/client';
import { AppStateService } from '../common/ui-state.service';
import { TranslateService } from '../i18n/translate.service';
import { NewPassword } from '../authentication/password.model';
import { BsModalService } from 'ngx-bootstrap/modal';
import { PasswordService } from '../authentication/password.service';
import { AlertService } from '../alert/alert.service';
import { ModalService } from '../modal/modal.service';
import { UserPreferencesService } from '../common/user-preferences/user-preferences.service';
export interface User extends IUser {
    phone: string;
    sendPasswordResetEmail: boolean;
    newsletter?: boolean;
}
export declare class UserEditComponent implements OnInit {
    state: AppStateService;
    translate: TranslateService;
    passwordService: PasswordService;
    modalConfirmService: ModalService;
    private bsModalService;
    private alert;
    private userService;
    private tenantLoginOptionsService;
    private tenantService;
    private userPreferencesService;
    lang: string;
    loading: boolean;
    set user(u: User);
    get user(): User;
    showProductUsageSetting: boolean;
    isUsageTrackingEnabled: boolean;
    onUser: EventEmitter<User>;
    onLanguage: EventEmitter<string>;
    onProductExperience: EventEmitter<boolean>;
    onCancel: EventEmitter<void>;
    userHasActiveTotp: boolean;
    userCanSetupTotp: boolean;
    isPhoneRequired: boolean;
    userIsExternal: boolean;
    isTfaEnabled: boolean;
    private _user;
    constructor(state: AppStateService, translate: TranslateService, passwordService: PasswordService, modalConfirmService: ModalService, bsModalService: BsModalService, alert: AlertService, userService: UserService, tenantLoginOptionsService: TenantLoginOptionsService, tenantService: TenantService, userPreferencesService: UserPreferencesService);
    ngOnInit(): Promise<void>;
    get langs(): any;
    setupTotp(): void;
    cancel(): void;
    save(): Promise<void>;
    onNewPasswordChanged(newPassword: NewPassword): void;
    private initializeTotpSettings;
    private canUserSetupTotp;
    private saveAfterPasswordConfirmation;
}
