import { StateService } from '../common/state-service.abstract';
import { BehaviorSubject } from 'rxjs';
import { UserMenuItem } from './user.model';
export declare class UserMenuService extends StateService {
    state$: BehaviorSubject<any>;
    /**
     * Returns the current state.
     * @readonly
     * @returns The current set of actions.
     */
    get state(): any;
    /**
     * Adds a new item to the search in the header.
     * @param item The item to add.
     */
    add(item: UserMenuItem): void;
    /**
     * Removes an search from the header.
     * @param item The item to remove.
     */
    remove(item: UserMenuItem): void;
}
