import { CanActivate } from '@angular/router';
import { TenantUiService } from '@c8y/ngx-components';
export declare class DefaultSubscriptionsGuard implements CanActivate {
    private tenantUiService;
    private active;
    constructor(tenantUiService: TenantUiService);
    /**
     * Checks if default subscriptions feature should be active,
     * i.e. whether the current tenant is the management or an enterprise tenant.
     * **Note: the check is executed only once in the runtime.**
     *
     * @returns True, if the feature should be active.
     */
    canActivate(): Promise<boolean>;
}
