import { IApplication } from '@c8y/client';
/** The list of partial application objects. */
export declare type PartialAppsList = Array<Partial<IApplication>>;
/** The interface for default subscriptions configuration. */
export interface DefaultSubscriptions {
    /** Whether the list of on tenant creation subscriptions is overridden in the current tenant. Won't be defined for inherited configuration. */
    overrideOnCreationSubscriptions?: boolean;
    /** The list of applications subscribed to new tenants on creation. */
    onCreationSubscriptions: PartialAppsList;
    /** Whether the list of on platform upgrade subscriptions is overridden in the current tenant. Won't be defined for inherited configuration. */
    overrideOnUpgradeSubscriptions?: boolean;
    /** The list of applications subscribed to existing tenants on platform upgrade. */
    onUpgradeSubscriptions: PartialAppsList;
}
/** The context for evaluating default subscriptions configuration */
export declare enum DefaultSubscriptionsContext {
    /** Current tenant context (only current tenant options are taken into account). */
    CURRENT_TENANT = 0,
    /** Parent tenant context (only parent tenant options are taken into account). */
    PARENT_TENANT = 1
}
