import { Type } from '@angular/core';
import { ColumnDataType, SortOrder, FilterPredicateFunction, ColumnConfig } from '@c8y/ngx-components';
import { DeviceGridColumn, DeviceGridColumnFilteringConfig, DeviceGridColumnSortingConfig } from '../device-grid.models';
export declare class BaseDeviceGridColumn implements DeviceGridColumn {
    name: string;
    path?: string;
    header?: string;
    dataType?: ColumnDataType;
    visible?: boolean;
    positionFixed?: boolean;
    gridTrackSize?: string;
    headerCSSClassName?: string | string[];
    headerCellRendererComponent?: Type<any>;
    cellCSSClassName?: string | string[];
    cellRendererComponent?: Type<any>;
    sortable?: boolean;
    sortingConfig?: DeviceGridColumnSortingConfig;
    sortOrder?: SortOrder;
    filterable?: boolean;
    filteringConfig?: DeviceGridColumnFilteringConfig;
    filteringFormRendererComponent?: Type<any>;
    filterPredicate?: string | FilterPredicateFunction;
    externalFilterQuery?: string | object;
    constructor(config?: ColumnConfig);
    /**
     * Gets a label template to be used in the schema-form's `type: 'template'` form item.
     * @param label The label to be displayed.
     * @param options Additional options:
     *   - `showWildcardTooltip`: `boolean` - appends a tooltip explaining wildcard usage
     * @returns The string with the template.
     */
    getLabelTemplate(label: string, options?: {
        showWildcardTooltip?: boolean;
    }): string;
}
