import { Column, ServerSideDataResult } from '@c8y/ngx-components';
export declare type DataCallback = (serverSideDataResult: ServerSideDataResult) => ServerSideDataResult;
export interface DeviceGridColumn extends Column {
    filteringConfig?: DeviceGridColumnFilteringConfig;
    sortingConfig?: DeviceGridColumnSortingConfig;
}
export interface DeviceGridColumnFilteringConfig {
    /** Defines a JSON schema for filtering config model, if schema form component is used to render the form. */
    schema?: object;
    /** Defines a form structure for filtering config model, if schema form component is used to render the form. */
    form?: object;
    /**
     * Transforms a filtering config model (e.g. coming from schema form component) to a query object.
     * However, using schema form component is not necessary.
     * Model can be defined arbitrarily but must converted to a valid query object.
     * @param model An object with defined structure (e.g. by schema).
     * @returns A query object to be used to generate a query string (QueryUtils).
     */
    getFilter: (model: any) => any;
}
export interface DeviceGridColumnSortingConfig {
    pathSortingConfigs: PathSortingConfig[];
}
export interface PathSortingConfig {
    path: string;
    sortOrderModifier?: SortOrderModifier;
}
export interface ContextConfig {
    groupId: string;
    excludeChildren: boolean;
}
export declare const enum SortOrderModifier {
    Keep = 0,
    Invert = 1
}
export declare const enum DeviceGridActionType {
    Delete = "DELETE"
}
export declare const enum DeviceGridBulkActionType {
}
