import { OnInit } from '@angular/core';
import { IManagedObject, InventoryService, IResultList } from '@c8y/client';
import { TranslateService } from '@ngx-translate/core';
import { AlertService, ModalService } from '@c8y/ngx-components';
import { BsModalService } from 'ngx-bootstrap/modal';
import { DeviceProfileService } from './device-profile.service';
import { Router } from '@angular/router';
import { BehaviorSubject, Observable } from 'rxjs';
export declare class DeviceProfileListComponent implements OnInit {
    private inventoryService;
    private translateService;
    private modalService;
    private alertService;
    private bsModalService;
    private router;
    private deviceProfileService;
    reloading: boolean;
    reload: BehaviorSubject<void>;
    deviceProfiles$: Observable<IResultList<IManagedObject>>;
    constructor(inventoryService: InventoryService, translateService: TranslateService, modalService: ModalService, alertService: AlertService, bsModalService: BsModalService, router: Router, deviceProfileService: DeviceProfileService);
    ngOnInit(): void;
    loadDeviceProfiles(): void;
    createDeviceProfile(): Promise<void>;
    duplicateDeviceProfile(deviceProfile: any): Promise<void>;
    deleteDeviceProfile(deviceProfile: any): Promise<void>;
    private delete;
}
