import { OnInit } from '@angular/core';
import { Location } from '@angular/common';
import { ActivatedRoute } from '@angular/router';
import { DeviceProfile } from './device-profile.model';
import { AlertService, BreadcrumbService } from '@c8y/ngx-components';
import { IManagedObject, InventoryService } from '@c8y/client';
import { BsModalService } from 'ngx-bootstrap/modal';
import { RepositoryType } from '@c8y/ngx-components/repository';
import { BehaviorSubject, Observable } from 'rxjs';
import { RepositoryService } from '@c8y/ngx-components/repository';
export declare class DeviceProfileComponent implements OnInit {
    private route;
    private alertService;
    private inventoryService;
    private location;
    private breadcrumbService;
    private bsModal;
    private repositoryService;
    DEVICE_TYPE_POPOVER: any;
    deviceProfile: DeviceProfile;
    profileName: string;
    private queriesUtil;
    constructor(route: ActivatedRoute, alertService: AlertService, inventoryService: InventoryService, location: Location, breadcrumbService: BreadcrumbService, bsModal: BsModalService, repositoryService: RepositoryService);
    ngOnInit(): Promise<void>;
    addFirmware(): void;
    getRepositoryEntriesWithVersions$(searchTerm$: BehaviorSubject<string>, repoType: RepositoryType): Observable<IManagedObject[]>;
    getAndAssignRepositoryBinaries(mos: IManagedObject[]): IManagedObject[];
    addConfiguration(): void;
    addSoftware(): void;
    get isDeviceProfileEmpty(): boolean;
    removeItem(removedItem: any, category: any): void;
    removeFirmware(): void;
    updateDeviceProfile(partialDeviceProfile: any): Promise<void>;
    private getDeviceProfile;
    private getDeviceTypeQuery;
}
