import { IManagedObject } from '@c8y/client';
export interface DeviceProfile extends Partial<IManagedObject> {
    name?: string;
    type: string;
    c8y_Filter: {
        type?: string;
    };
    c8y_DeviceProfile: {
        firmware?: DeviceProfileFirmware;
        software?: DeviceProfileSoftware[];
        configuration?: DeviceProfileConfiguration[];
    };
}
export interface DeviceProfileFirmware {
    name: string;
    version: string;
    url: string;
    isPatch: boolean;
    patchDependency?: string;
}
export interface DeviceProfileSoftware {
    name: string;
    version: string;
    url: string;
    action: string;
}
export interface DeviceProfileConfiguration {
    url: string;
    name: string;
    type: string;
}
export interface ComparisonResult {
    profile: {
        itemName: string;
        itemDetails?: string;
        itemUrl: string;
    };
    device: {
        itemName: string;
        itemDetails?: string;
        itemUrl: string;
    };
    comparisonAlert?: string;
}
export declare enum DeviceProfileOperation {
    APPLY_PROFILE = "c8y_DeviceProfile"
}
