import { IManagedObject, InventoryService, IOperation, IResultList, OperationService } from '@c8y/client';
import { DeviceProfile, ComparisonResult } from './device-profile.model';
import { AlertService } from '@c8y/ngx-components';
export declare class DeviceProfileService {
    private inventoryService;
    private operationService;
    private alertService;
    readonly dateFrom: Date;
    readonly dateTo: Date;
    private queriesUtil;
    private NOT_INSTALLED_WARNING;
    private VERSION_MISSMATCH_WARNING;
    private SAME_URL_WARNING;
    constructor(inventoryService: InventoryService, operationService: OperationService, alertService: AlertService);
    createDeviceProfile(deviceProfile: Partial<DeviceProfile>): Promise<import("@c8y/client").IResult<IManagedObject>>;
    getDeviceProfilesByDeviceType(deviceType: string): Promise<IResultList<IManagedObject>>;
    getDeviceProfiles(andQuery?: any): Promise<IResultList<IManagedObject>>;
    getProfileOperation(deviceId: string | number): Promise<IOperation>;
    createProfileOperation(device: IManagedObject, deviceProfile: Partial<DeviceProfile>): Promise<any>;
    getFirmwareItems(device: IManagedObject, selectedProfile: Partial<DeviceProfile>): ComparisonResult[];
    getSoftwareItems(device: IManagedObject, selectedProfile: Partial<DeviceProfile>): ComparisonResult[];
    getConfigurationItems(device: IManagedObject, selectedProfile: Partial<DeviceProfile>): ComparisonResult[];
    private getAlert;
    private createProfileComparison;
    private createProfileComparisonFromDeviceItems;
    private extendProfileComparisonWithProfileItems;
}
