import { OnDestroy, OnInit, Pipe } from '@angular/core';
import { IManagedObject, IOperation, IResultList } from '@c8y/client';
import { ActivatedRoute } from '@angular/router';
import { DeviceProfileService } from '../device-profile.service';
import { DeviceProfile, ComparisonResult } from '../device-profile.model';
import { AlertService, ManagedObjectRealtimeService, OperationRealtimeService } from '@c8y/ngx-components';
export declare class DeviceTabProfileComponent implements OnInit, OnDestroy {
    deviceRealtime: ManagedObjectRealtimeService;
    private deviceProfileService;
    private route;
    private operationRealtime;
    private alertService;
    device: IManagedObject;
    deviceProfiles: IResultList<IManagedObject>;
    selectedProfile: Partial<DeviceProfile>;
    operation: IOperation;
    firmwareItems: ComparisonResult[];
    softwareItems: ComparisonResult[];
    configurationItems: ComparisonResult[];
    filterPipe: Pipe;
    pattern: string;
    reloading: boolean;
    private operationsSubscription;
    private moOnDeleteSubscription;
    private moOnUpdateSubscription;
    constructor(deviceRealtime: ManagedObjectRealtimeService, deviceProfileService: DeviceProfileService, route: ActivatedRoute, operationRealtime: OperationRealtimeService, alertService: AlertService);
    ngOnInit(): Promise<void>;
    getDeviceProfilesAndUpdateProfileItems(): Promise<void>;
    selectProfile(mo: DeviceProfile): void;
    createOperation(): Promise<void>;
    setPipe(filterStr: string): void;
    ngOnDestroy(): void;
    updateProfileItems(device: any, profile: any): void;
    private subscribeToManagedObjects;
    private subscribeToOperations;
}
