import { DiagnosticsService } from './diagnostics.service';
import { ActivatedRoute } from '@angular/router';
import { BehaviorSubject } from 'rxjs';
import { ForOfRealtimeOptions, OperationRealtimeService } from '@c8y/ngx-components';
import { IManagedObject, IOperation } from '@c8y/client';
export declare class DiagnosticsComponent {
    private route;
    private diagnosticService;
    operationRealtime: OperationRealtimeService;
    statusIcons: {
        [x: number]: string;
    };
    statusClasses: {
        [x: number]: string;
    };
    deviceId: string;
    device$: BehaviorSubject<IManagedObject>;
    operations$: import("rxjs").Observable<import("@c8y/client").IResultList<IOperation>>;
    operationsPipe: import("rxjs").UnaryFunction<import("rxjs").Observable<IOperation[]>, import("rxjs").Observable<IOperation[]>>;
    realtimeOptions: ForOfRealtimeOptions;
    operationCount: number;
    constructor(route: ActivatedRoute, diagnosticService: DiagnosticsService, operationRealtime: OperationRealtimeService);
    onDiagnosticRequest(): void;
    onDelete(operation: IOperation): void;
    onCancel(operation: IOperation): void;
}
