import { Observable } from 'rxjs';
import { IManagedObject, IResultList, InventoryBinaryService, IOperation, OperationService } from '@c8y/client';
import { AlertService, ModalService } from '@c8y/ngx-components';
export declare class DiagnosticsService {
    private operationService;
    private inventoryBinary;
    private modalService;
    private alertService;
    readonly fragment = "c8y_DiagnosticReport";
    constructor(operationService: OperationService, inventoryBinary: InventoryBinaryService, modalService: ModalService, alertService: AlertService);
    isSupportedDevice(device: any): boolean;
    getOperations$(device$: Observable<IManagedObject>): Observable<IResultList<IOperation>>;
    createOperation(deviceId: string): Promise<void>;
    deleteOperation(operation: IOperation): Promise<void>;
    cancelOperation(operation: IOperation): Promise<void>;
    private getOperation;
    private deleteDiagnosticsBinary;
    private deleteDiagnosticsFragment;
}
