import { CdkStep, StepperSelectionEvent } from '@angular/cdk/stepper';
import { EventEmitter, OnDestroy, QueryList } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { AlertService, C8yStepper, ModalService } from '@c8y/ngx-components';
import { Observable } from 'rxjs';
import { OperationDetailsComponent } from '@c8y/ngx-components/operations/details';
import { OperationSchedule } from '@c8y/ngx-components/operations/bulk-operation-scheduler';
import { CustomStep } from './custom-step.directive';
import { OperationDetails, BulkOperationType, BulkOperationsService } from '@c8y/ngx-components/operations/bulk-operations-service';
export declare class BulkOperationStepper implements OnDestroy {
    private bulkOperationService;
    private modal;
    private alert;
    selectionChange: EventEmitter<StepperSelectionEvent>;
    customSteps: QueryList<CustomStep>;
    stepper: C8yStepper;
    operationDetailsComponent: OperationDetailsComponent;
    steps: CustomStep[];
    showStepper: boolean;
    showButtons: boolean;
    pendingStatus: boolean;
    stepperButtonsLabels: {
        custom: any;
    };
    deviceTypes$: Observable<string[]>;
    deviceQueryString: string;
    bulkOperationType: BulkOperationType;
    scheduleData: OperationSchedule;
    operationDetailsForm: FormGroup;
    operationDetails: OperationDetails;
    retrieveOperationDetails: () => OperationDetails | Promise<OperationDetails>;
    private deviceTypesSubject$;
    private endSubscriptions;
    constructor(bulkOperationService: BulkOperationsService, modal: ModalService, alert: AlertService);
    ngAfterViewInit(): void;
    changeDeviceTypes(deviceTypes: string | string[]): void;
    confirmDeviceSelection($event: {
        stepper: C8yStepper;
        step: CdkStep;
    }): Promise<void>;
    cancel(): void;
    scheduleBulkOperation(): Promise<void>;
    ngOnDestroy(): void;
    private close;
}
