import { BsModalService } from 'ngx-bootstrap/modal';
import { IOperation, OperationService } from '@c8y/client';
export declare class SingleOperationDetailsService {
    private operationService;
    private modalService;
    constructor(operationService: OperationService, modalService: BsModalService);
    /**
     * Opens a modal window with the details of given single operation.
     * @param operationOrOperationId Operation's object or id.
     * @param options Additional options:
     * - `collapsed`: boolean - whether the details pane should be initially collapsed
     * - `readOnly`: boolean - whether the details should be displayed in read-only mode
     */
    openDetails(operationOrOperationId: IOperation | string | number, options?: {
        collapsed?: boolean;
        readOnly?: boolean;
    }): Promise<void>;
}
