import { EventEmitter } from '@angular/core';
import { IStatusOption } from './status-option.model';
export declare class StatusFilterComponent {
    statusOptions: Array<{
        selected: boolean;
        option: IStatusOption;
    }>;
    /** List of filter options to be displayed */
    set options(options: IStatusOption[]);
    /**
     * Allows multiple options to be active simultaneosly.
     */
    set _multiple(multiple: boolean);
    /** Display the filter as a small button group */
    set _small(small: boolean);
    get displaySmall(): boolean;
    onFilterChanged: EventEmitter<IStatusOption[]>;
    isAllButtonSelected: boolean;
    private multiple;
    private small;
    changeFilter(option: {
        selected: boolean;
        option: IStatusOption;
    }): void;
    removeFilter(): void;
    /**
     * Allows the filter to be initalliy displayed with some preset filters.
     *
     * @param filters An `IStatusOption` array defining filter options to be preset.
     * @param emit  (optional) If `true` component will emit `onFilterChanged` event.
     */
    preset(filters: IStatusOption[], emit?: boolean): void;
    reset(): void;
    activeFilters(): IStatusOption[];
    isFilterApplied(): boolean;
    private emitSelectedOptions;
}
