import { StepperSelectionEvent } from '@angular/cdk/stepper';
import { OnDestroy } from '@angular/core';
import { IManagedObject } from '@c8y/client';
import { TranslateService } from '@ngx-translate/core';
import { BehaviorSubject } from 'rxjs';
import { BaseStepperComponent } from '@c8y/ngx-components/operations/bulk-operation-stepper';
import { BulkOperationsService, OperationDetails } from '@c8y/ngx-components/operations/bulk-operations-service';
export declare class StepperBulkTypeFirmwareComponent extends BaseStepperComponent implements OnDestroy {
    private bulkOperationService;
    private translate;
    readonly descriptionTemplate: string;
    textFilter$: BehaviorSubject<string>;
    stepData: {
        firmware: IManagedObject;
        versionOrPatch: IManagedObject;
    };
    selectedFirmware: IManagedObject;
    selectedVersionOrPatch: IManagedObject;
    private subscription;
    constructor(bulkOperationService: BulkOperationsService, translate: TranslateService);
    goToVersionOrPatchStep({ stepper }: {
        stepper: any;
    }): void;
    onVersionOrPatchSelected(versionOrPatch: IManagedObject): void;
    onFirmwareSelected(fw: IManagedObject): void;
    ngOnDestroy(): void;
    protected retrieveOperationPrototype(): OperationDetails;
    protected onSelectionChange(event: StepperSelectionEvent): void;
}
