import { IManagedObject, InventoryService, IResultList, FetchClient, IdentityService } from '@c8y/client';
export declare class LpwanSetDeviceProtocolService {
    private inventoryService;
    private client;
    private identityService;
    supportedDevicesCfgs: {
        name: string;
        match: (device: any) => boolean;
        protocolTypes: string[];
        externalIdTypes: string[];
    }[];
    private readonly header;
    constructor(inventoryService: InventoryService, client: FetchClient, identityService: IdentityService);
    refreshCache(device: any): Promise<import("@c8y/client").IFetchResponse>;
    getMicroserviceUrl(device: any): string;
    isSupportedDevice(device: IManagedObject): boolean;
    getCurrentProtocol(device: IManagedObject): Promise<IManagedObject>;
    applyProtocol(device: IManagedObject, selectedProtocol: IManagedObject): Promise<import("@c8y/client").IResult<IManagedObject>>;
    getAvailableProtocols(device: IManagedObject): Promise<IResultList<IManagedObject>>;
    private getProtocolTypesMatchingDevice;
    private getExternalId;
}
