export interface OpcuaDeviceTypeMappingObject {
    id?: number;
    browsePath?: string[];
}
export interface OpcuaDeviceType {
    id?: any;
    name: string;
    fieldbusType?: string;
    fieldbusVersion?: number;
    description?: string;
    unit?: string;
    referencedServerId: string;
    referencedRootNodeId: string;
    subscriptionType: {
        type: string;
        cyclicReadParameters?: {
            rate: number;
        };
        subscriptionParameters?: {
            samplingRate?: number;
            deadbandType?: string;
            deadbandValue?: number;
            ranges?: string;
            queueSize?: number;
        };
    };
    mappings?: OpcuaDeviceTypeMappingObject[];
    overriddenSubscriptions?: any;
    applyConstraints: AutoApplyConstraints;
    enabled: string;
}
export interface AutoApplyConstraints {
    browsePathMatchesRegex: string;
    serverObjectHasFragment: string;
    matchesNodeIds: string[];
    matchesServerIds: string[];
}
