export interface OpcuaServer {
    name: string;
    id: string;
    gatewayId?: string;
    subtitle?: string;
    connectionStatus?: any;
    enabeled?: any;
    config: OpcuaServerConfig;
    quickInfo?: {
        padlock?: string;
        padlockMsg?: string;
    };
    active: true | false;
}
export interface OpcuaServerConfig {
    securityMode: string;
    keystorePass?: any;
    keystoreFilename?: string;
    keystoreBinaryId?: any;
    certificatePass?: any;
    userIdentityMode?: string;
    serverUrl?: string;
    userName?: string;
    userPassword?: string;
    passwordEncrypted?: boolean;
    rescanCron?: any;
    timeout?: number;
    autoReconnect?: boolean;
    targetConnectionState?: 'enabled' | 'disabled' | null;
    statusCheckInterval?: number;
    valid?: boolean;
}
