import { IManagedObject } from '@c8y/client';
export interface Export extends IManagedObject {
    c8y_ScheduleConfiguration: Schedule[];
}
export interface Schedule {
    timestamp: number;
    emailConfig: EmailConfig;
    cronConfig: CronConfig;
}
export interface EmailConfig {
    to: string[];
    cc: string[];
    bcc: string[];
    replyTo: string;
    text: string;
    subject: string;
}
export interface CronConfig {
    month: string;
    hour: string;
    weekday: string;
    day: string;
    minute: string;
}
export interface EmittedCron {
    cron: string;
    valid: boolean;
}
export interface EmitterPayload {
    success: boolean;
    message: string;
    schedule: Schedule;
}
export declare enum ActionType {
    CREATE = "create",
    EDIT = "edit",
    DUPLICATE = "duplicate"
}
export declare enum Base {
    Initial = 1,
    Hour = 2,
    Day = 3,
    Week = 4,
    Month = 5,
    Year = 6
}
