import { OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { IManagedObject, Realtime } from '@c8y/client';
import { DeviceConfigurationService } from './device-configuration.service';
import { DeviceConfigurationListEmptyState, ConfigurationSnapshot, SupportedConfigurationItem } from '../repository.model';
import { RepositoryService } from '../repository.service';
import { TextBasedConfigurationComponent } from './text-based-configuration.component';
export declare class DeviceConfigurationComponent implements OnInit {
    private route;
    private deviceConfigurationService;
    private realtime;
    private repositoryService;
    supportedConfigurations: SupportedConfigurationItem[];
    showBinaryBasedConfig: boolean;
    configurationType: string;
    configSnapshot: Partial<ConfigurationSnapshot>;
    repositorySnapshots: IManagedObject[];
    repositorySnapshot: ConfigurationSnapshot;
    repositorySnapshotsEmptyState: DeviceConfigurationListEmptyState;
    device: IManagedObject;
    isLegacy: boolean;
    showTextBasedConfig: boolean;
    reloading: boolean;
    textBasedConfigurationComponent: TextBasedConfigurationComponent;
    constructor(route: ActivatedRoute, deviceConfigurationService: DeviceConfigurationService, realtime: Realtime, repositoryService: RepositoryService);
    ngOnInit(): void;
    onConfigTypeSelected(config: any): Promise<void>;
    onRepositoryConfigSelected(config: any): Promise<void>;
    updateSnapshots(repositorySnapsOnly?: boolean): Promise<void>;
}
