import { AfterContentInit, EventEmitter, OnInit } from '@angular/core';
import { IManagedObject, IResultList } from '@c8y/client';
import { Observable } from 'rxjs';
import { DeviceSoftware, DeviceSoftwareChange, SoftwareFilterCriteria } from '../repository.model';
import { AdvancedSoftwareService } from './advanced-software.service';
export declare class DeviceSoftwareListComponent implements OnInit, AfterContentInit {
    private advancedSoftwareService;
    set softwareList(softwareList: DeviceSoftware[]);
    device: IManagedObject;
    deviceSoftwareChanges: DeviceSoftwareChange[];
    filterCriteria$: Observable<SoftwareFilterCriteria>;
    update: EventEmitter<DeviceSoftware>;
    remove: EventEmitter<DeviceSoftware>;
    onListEmpty: EventEmitter<boolean>;
    softwareItems$: Observable<IResultList<DeviceSoftware>>;
    showUpdate: boolean;
    showRemove: boolean;
    emptyList: boolean;
    noSearchResults: boolean;
    private legacySoftwareList$;
    constructor(advancedSoftwareService: AdvancedSoftwareService);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    isSoftwareGoingToBeChanged(software: DeviceSoftware): boolean;
    private getAdvancedSoftwareList;
    private getLegacySoftwareList;
    private notifyListEmpty;
}
