import { OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Observable, BehaviorSubject } from 'rxjs';
import { IManagedObject, InventoryService, IOperation } from '@c8y/client';
import { DeviceSoftware, DeviceSoftwareChange } from '../repository.model';
import { RepositoryService } from '../repository.service';
import { AdvancedSoftwareService } from './advanced-software.service';
export declare class SoftwareDeviceTabComponent implements OnInit {
    private route;
    private repository;
    private inventory;
    private advancedSoftwareService;
    deviceId: string | number;
    device$: BehaviorSubject<IManagedObject>;
    deviceTypeQuery$: Observable<object>;
    list$: Observable<DeviceSoftware[]>;
    changes$: BehaviorSubject<DeviceSoftwareChange[]>;
    changesOperation$: BehaviorSubject<IOperation>;
    changesInProgress$: Observable<boolean>;
    reloading: boolean;
    showSoftwareChanges: boolean;
    constructor(route: ActivatedRoute, repository: RepositoryService, inventory: InventoryService, advancedSoftwareService: AdvancedSoftwareService);
    ngOnInit(): Promise<void>;
    addChanges(requestedChanges: DeviceSoftwareChange[]): void;
    dropChange(changeToBeDropped: DeviceSoftwareChange): void;
    areSameChanges(change1: DeviceSoftwareChange, change2: DeviceSoftwareChange): boolean;
    clearChanges(): void;
    loadDevice(): Promise<void>;
    applyChanges(): Promise<void>;
    private loadOperation;
    private trackOperation;
    private displayChangesFromOperation;
    private isInProgress;
}
