import { OnDestroy, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { IManagedObject, InventoryService, IResultList } from '@c8y/client';
import { AlertService, ModalService } from '@c8y/ngx-components';
import { TranslateService } from '@ngx-translate/core';
import { BsModalService } from 'ngx-bootstrap/modal';
import { BehaviorSubject, Observable, Subject } from 'rxjs';
import { RepositoryService } from '../repository.service';
import { SoftwareTypeComponent } from './software-type.component';
export declare class SoftwareDetailsComponent implements OnInit, OnDestroy {
    private activatedRoute;
    private inventoryService;
    private repositoryService;
    private alertService;
    private translateService;
    private modalService;
    private bsModalService;
    softwareType: SoftwareTypeComponent;
    reload$: Subject<void>;
    reloading$: BehaviorSubject<boolean>;
    softwareTypeObject: IManagedObject;
    isSoftwareTypeChanged: boolean;
    updateSoftware$: Subject<Partial<IManagedObject>>;
    softwareUpdated$: Subject<IManagedObject>;
    baseVersionsUpdated$: Subject<void>;
    software$: Observable<IManagedObject>;
    baseVersions$: Observable<IResultList<IManagedObject>>;
    isLegacy$: Observable<boolean>;
    destroy$: Subject<boolean>;
    constructor(activatedRoute: ActivatedRoute, inventoryService: InventoryService, repositoryService: RepositoryService, alertService: AlertService, translateService: TranslateService, modalService: ModalService, bsModalService: BsModalService);
    ngOnInit(): void;
    getBinaryName$(binaryUrl: any): Observable<string>;
    addBaseVersion(): void;
    deleteBaseVersion(baseVersion: IManagedObject): Promise<void>;
    onSelectSoftwareType(software: any): void;
    ngOnDestroy(): void;
}
