import { EventEmitter, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { IManagedObject } from '@c8y/client';
import { ActionControl, AlertService, DataSourceModifier, ModalService, ServerSideDataResult } from '@c8y/ngx-components';
import { DeviceGridColumn, DeviceGridService } from '@c8y/ngx-components/device-grid';
import { TranslateService } from '@ngx-translate/core';
import { BsModalService } from 'ngx-bootstrap/modal';
import { RepositoryService } from '../repository.service';
export declare class SoftwareListComponent implements OnInit {
    private repositoryService;
    private gridService;
    private modalService;
    private bsModalService;
    private translateService;
    private alertService;
    private router;
    private activatedRoute;
    sizeRequest: Promise<number>;
    sizeRequestDone: boolean;
    refresh$: EventEmitter<void>;
    columns: DeviceGridColumn[];
    actionControls: ActionControl[];
    serverSideDataCallback: any;
    pagination: {
        pageSize: number;
        currentPage: number;
    };
    constructor(repositoryService: RepositoryService, gridService: DeviceGridService, modalService: ModalService, bsModalService: BsModalService, translateService: TranslateService, alertService: AlertService, router: Router, activatedRoute: ActivatedRoute);
    ngOnInit(): void;
    onDataSourceModifier(dataSourceModifier: DataSourceModifier): Promise<ServerSideDataResult>;
    addSoftware(): void;
    editSoftware(software: Partial<IManagedObject>): void;
    deleteSoftware(software: IManagedObject): Promise<void>;
    trackByName(_index: any, column: DeviceGridColumn): string;
}
