import { EventEmitter } from '@angular/core';
import { ActionControl, BulkActionControl, DataGridComponent, DataSourceModifier, FilteringActionType, FilteringModifier, Pagination, ServerSideDataResult } from '@c8y/ngx-components';
import { DeviceGridColumn } from '@c8y/ngx-components/device-grid';
import { IManagedObject, SmartGroupsService } from '@c8y/client';
import { AssetSearchService } from './search.service';
import { SubAssetsService } from '@c8y/ngx-components/sub-assets';
import { BsModalService } from 'ngx-bootstrap/modal';
export declare class SearchGridComponent {
    searchService: AssetSearchService;
    private bsModalService;
    private smartGroupsService;
    private subAssetsGridService;
    parentGroup: IManagedObject;
    title: string;
    loadingItemsLabel: string;
    set _columns(value: DeviceGridColumn[]);
    set _pagination(value: Pagination);
    set _actionControls(value: ActionControl[]);
    selectable: boolean;
    set _bulkActionControls(value: BulkActionControl[]);
    onColumnsChange: EventEmitter<DeviceGridColumn[]>;
    searchText: string;
    filteringName: string;
    columns: DeviceGridColumn[];
    pagination: Pagination;
    actionControls: ActionControl[];
    bulkActionControls: BulkActionControl[];
    serverSideDataCallback: any;
    refresh: EventEmitter<any>;
    dataGrid: DataGridComponent;
    private sizeCount;
    constructor(searchService: AssetSearchService, bsModalService: BsModalService, smartGroupsService: SmartGroupsService, subAssetsGridService: SubAssetsService);
    ngOnInit(): void;
    trackByName(_index: any, column: DeviceGridColumn): string;
    onDataSourceModifier(dataSourceModifier: DataSourceModifier): Promise<ServerSideDataResult>;
    setActionControls(): void;
    updateFiltering(columnNames: string[], action: {
        type: FilteringActionType;
        payload?: {
            filteringModifier: FilteringModifier;
        };
    }): void;
    configChange(config: any): void;
    private onDeleteAsset;
}
