import { EventEmitter, ElementRef } from '@angular/core';
import { FormGroup, FormBuilder } from '@angular/forms';
import { Subscription } from 'rxjs';
import { DeviceGridService } from '@c8y/ngx-components/device-grid';
import { C8yStepper, Pagination, AlertService } from '@c8y/ngx-components';
import { AddGroupService } from './add-group.service';
import { SubAssetsService } from '../sub-assets.service';
export declare class AddGroupComponent {
    protected deviceGridService: DeviceGridService;
    private fb;
    private addGroupService;
    private alert;
    private subAssetsService;
    currentGroupId: string;
    refresh: EventEmitter<any>;
    onDeviceQueryStringChange: EventEmitter<string>;
    onCancel: EventEmitter<any>;
    stepper: C8yStepper;
    nameInputRef: ElementRef;
    deviceQueryStringOutput: string;
    formGroupStepOne: FormGroup;
    pendingStatus: boolean;
    pagination: Pagination;
    selected: string[];
    subscription: Subscription;
    canCreateGroup: boolean;
    canAssignDevice: boolean;
    readonly ITEMS_SELECT_LIMIT: number;
    readonly btnLabels: {
        next: any;
        cancel: any;
        create: any;
    };
    private nameInput;
    constructor(deviceGridService: DeviceGridService, fb: FormBuilder, addGroupService: AddGroupService, alert: AlertService, subAssetsService: SubAssetsService);
    onEnterKeyDown(event: KeyboardEvent): void;
    onEscapeKeyDown(event: KeyboardEvent): void;
    ngOnInit(): Promise<void>;
    ngAfterViewInit(): void;
    createGroup(): Promise<void>;
    onSelected(selectedDevicesIDs: string[]): void;
    resetStepper(): void;
    ngOnDestroy(): void;
    private isGroupDetailsStep;
    private isAssignDeviceStep;
    private setFocusOnNameInput;
}
