import { EventEmitter } from '@angular/core';
import { IManagedObject, InventoryService, SmartGroupsService } from '@c8y/client';
import { AlertService, ModalService } from '@c8y/ngx-components';
import { DeviceGroupService } from '@c8y/ngx-components/assets-navigator';
import { TranslateService } from '@ngx-translate/core';
import { SubAssetsService } from './sub-assets.service';
export declare class GroupInfoComponent {
    private inventory;
    private subAssetsService;
    private deviceGroupService;
    private smartGroupsService;
    private alertService;
    private translate;
    private modalService;
    group: IManagedObject;
    onGroupChange: EventEmitter<any>;
    canEdit: boolean;
    groupIcon: string;
    smartGroupFilter: string;
    filterHintMsg: string;
    private filterMsg;
    private canEditMsg;
    private readonly GROUP_UPDATED_MSG;
    constructor(inventory: InventoryService, subAssetsService: SubAssetsService, deviceGroupService: DeviceGroupService, smartGroupsService: SmartGroupsService, alertService: AlertService, translate: TranslateService, modalService: ModalService);
    ngOnInit(): Promise<void>;
    isSmartGroup(): boolean;
    update(partialGroup: Partial<IManagedObject>): Promise<void>;
    private setHintMsg;
    private updateGroup;
    private updateSmartGroup;
    private setGroup;
    private isQueryExecutable;
}
