import { EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { IIdentified, IManagedObject } from '@c8y/client';
import { DisplayOptions } from '@c8y/ngx-components';
import { DeviceGroupService } from '@c8y/ngx-components/assets-navigator';
import { SubAssetsService } from './sub-assets.service';
export declare class SubAssetsComponent implements OnInit, OnDestroy {
    private route;
    private deviceGroupService;
    private subAssetsService;
    currentGroupId: IIdentified;
    showChildrenForDevice: IManagedObject;
    title: string;
    toggle: boolean;
    showAddGroup: boolean;
    showAssignDevices: boolean;
    requestInProgress: boolean;
    group: IManagedObject;
    showAssignChildDevices: boolean;
    refresh: EventEmitter<any>;
    filterable: boolean;
    shouldDisableAddGroup: boolean;
    shouldDisableAssignDevices: boolean;
    displayOptions: DisplayOptions;
    private dataSub;
    constructor(route: ActivatedRoute, deviceGroupService: DeviceGroupService, subAssetsService: SubAssetsService);
    ngOnInit(): Promise<void>;
    groupChange(group: IManagedObject): void;
    isSmartGroup(): boolean;
    ngOnDestroy(): void;
}
