import { OnInit } from '@angular/core';
import { Location } from '@angular/common';
import { TranslateService } from '@ngx-translate/core';
import { BehaviorSubject } from 'rxjs';
import { ICurrentTenant, ITenant, TenantService, TenantStatus, UserService } from '@c8y/client';
import { ActionControl, AlertService, AppStateService, Column, DisplayOptions, ModalService, Pagination, TenantUiService, PasswordService } from '@c8y/ngx-components';
export declare class TenantListComponent implements OnInit {
    appState: AppStateService;
    private alertService;
    private modalService;
    private translateService;
    private tenantService;
    private tenantUiService;
    private location;
    private passwordService;
    private userService;
    tenants$: BehaviorSubject<ITenant[]>;
    currentTenant: ICurrentTenant;
    isManagementTenant: boolean;
    TOP_TENANT_NAME: string;
    title: string;
    loadMoreItemsLabel: string;
    loadingItemsLabel: string;
    displayOptions: DisplayOptions;
    columns: Column[];
    pagination: Pagination;
    showSearch: boolean;
    actionControls: ActionControl[];
    TenantStatus: typeof TenantStatus;
    constructor(appState: AppStateService, alertService: AlertService, modalService: ModalService, translateService: TranslateService, tenantService: TenantService, tenantUiService: TenantUiService, location: Location, passwordService: PasswordService, userService: UserService);
    ngOnInit(): Promise<void>;
    loadTenants(): void;
    getColumns(): Column[];
    getPagination(): Pagination;
    getActionControls(): ActionControl[];
    createTenant(): void;
    goToDetails(tenant: ITenant): void;
    activateTenant(tenant: any): Promise<void>;
    suspendTenant(tenant: any): Promise<void>;
    delete(tenant: any): Promise<void>;
    isActive(tenant: ITenant): boolean;
    isSuspended(tenant: ITenant): boolean;
    downloadNewsletterEmails(): Promise<void>;
}
