import { InjectionToken } from '@angular/core';
import { NavigatorNode } from '@c8y/ngx-components';
export declare const TENANTS_MODULE_CONFIG: InjectionToken<TenantsModuleConfig>;
/**
 * Configuration object for `TenantsModule`.
 */
export interface TenantsModuleConfig {
    /**
     * Allows for hiding or customizing "Subtenants" navigator node:
     * - `subtenantsNavigatorNode: true` - shows the default navigator node (default),
     * - `subtenantsNavigatorNode: false` - hides the navigator node,
     * - `subtenantsNavigatorNode: { label: 'My subtenants' }` - overrides default navigator node,
     * - `subtenantsNavigatorNode: new NavigatorNode({ label: 'My subtenants' })` - overrides default navigator node.
     */
    subtenantsNavigatorNode?: boolean | Partial<NavigatorNode>;
}
