import { AppStateService, TenantUiService } from '@c8y/ngx-components';
import { BasicAuth, FetchClient, ICredentials } from '@c8y/client';
export declare class AuthBridgeService {
    injector: any;
    private basicAuth;
    private fetchClient;
    private appState;
    private tenantUiService;
    constructor(injector: any, basicAuth: BasicAuth, fetchClient: FetchClient, appState: AppStateService, tenantUiService: TenantUiService);
    updateBasicAuth(credentials: ICredentials): void;
    hookAuth(): void;
    setToken(token?: string, tfa?: string, type?: string): void;
    getPreferredLoginOption(): import("@c8y/client").ITenantLoginOption;
}
export declare function authBridgeServiceFactory(injector: any, basicAuth: BasicAuth, fetchClient: FetchClient, appState: AppStateService, tenantUiService: TenantUiService): AuthBridgeService;
export declare const authBridgeServiceProvider: {
    provide: typeof AuthBridgeService;
    useFactory: typeof authBridgeServiceFactory;
    deps: (string | typeof AppStateService | typeof BasicAuth | typeof FetchClient | typeof TenantUiService)[];
};
